/*
* Copyright (c) 2000, 2010 IBM Corporation and others.
* All rights reserved. This program and the accompanying materials 
* are made available under the terms of the Eclipse Public License v1.0
* which is available at
* http://www.eclipse.org/legal/epl-v10.html
*/

package org.eclipse.datatools.sqltools.parsers.sql.query;

public class SQLQueryParserprs implements lpg.lpgjavaruntime.ParseTable, SQLQueryParsersym {

    public interface IsKeyword {
        public final static byte isKeyword[] = {0,
            0,0,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,0,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,0,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,0,0,0,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0
        };
    };
    public final static byte isKeyword[] = IsKeyword.isKeyword;
    public final boolean isKeyword(int index) { return isKeyword[index] != 0; }

    public interface BaseCheck {
        public final static short baseCheck[] = {0,
            1,3,2,1,1,1,1,1,1,1,
            1,4,4,4,6,6,1,3,1,3,
            0,1,2,1,3,1,3,1,3,4,
            1,1,1,2,3,4,3,4,5,4,
            1,2,4,1,2,6,1,1,1,1,
            1,1,3,1,4,1,1,2,2,1,
            1,1,1,1,1,1,1,1,1,1,
            2,5,2,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,4,1,1,
            2,1,1,1,4,4,4,6,6,6,
            1,1,1,1,1,5,3,7,1,1,
            4,4,5,5,4,1,5,3,7,3,
            7,1,4,4,1,5,1,1,1,0,
            2,1,1,1,1,1,1,1,1,5,
            1,3,1,1,1,1,1,1,1,4,
            3,3,1,1,3,0,3,3,1,1,
            1,1,1,1,1,1,2,2,1,1,
            3,3,3,3,2,1,1,5,1,3,
            5,6,1,1,1,5,1,3,3,1,
            1,1,3,1,1,1,3,1,1,1,
            6,5,4,3,8,7,3,1,1,3,
            6,5,6,5,1,1,5,4,8,2,
            1,1,1,2,1,1,4,5,3,4,
            4,3,1,0,1,1,1,0,1,0,
            1,0,1,0,2,0,1,1,0,2,
            0,3,0,2,0,2,0,1,0,1,
            0,3,5,5,0,2,0,1,2,2,
            2,0,1,0,2,2,0,3,0,2,
            0,1,0,3,0,1,0,1,0,2,
            0,3,1,3,1,1,2,2,1,3,
            5,5,1,2,1,2,1,2,1,1,
            2,10,3,1,1,5,4,1,1,1,
            1,1,1,1,1,3,1,1,3,1,
            1,3,1,3,1,1,1,1,1,1,
            1,1,1,1,1,4,1,4,1,4,
            1,1,1,2,1,1,1,1,1,3,
            4,4,2,1,1,3,3,1,1,3,
            1,2,9,6,3,4,4,5,1,1,
            1,1,1,1,1,3,2,1,3,1,
            3,1,1,3,2,4,1,3,7,7,
            1,3,6,3,3,1,1,3,2,0,
            1,3,6,-139,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-2,
            0,0,-266,0,0,-81,0,0,0,0,
            0,0,0,-27,-13,0,0,0,0,0,
            -4,-21,-5,0,-52,0,-186,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-90,0,0,-12,0,
            0,0,0,0,0,0,-56,-26,-10,0,
            0,0,0,-70,0,0,0,0,0,-161,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-17,0,0,0,0,0,
            0,0,0,0,0,0,0,-34,0,0,
            0,0,-74,0,0,0,0,0,0,-3,
            0,0,0,0,-147,0,-84,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-48,0,0,0,0,0,-182,0,
            0,-137,0,0,0,0,-71,-1,0,0,
            0,0,0,0,-35,0,0,0,0,-88,
            0,0,0,-24,0,0,-38,0,-36,0,
            0,0,0,-117,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-31,
            0,-83,-114,0,0,-32,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -108,0,0,0,0,0,-7,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -309,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-144,-62,0,0,
            0,0,-295,0,0,-89,0,0,0,0,
            0,-11,0,0,0,0,0,-6,0,0,
            0,-91,0,0,0,-146,0,-14,0,0,
            0,0,0,0,-160,0,0,-314,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-15,0,0,-162,0,0,-118,
            0,0,0,0,0,0,0,-157,0,0,
            0,0,0,0,-73,0,-85,0,0,0,
            0,-225,0,0,0,0,0,0,0,0,
            0,0,0,0,-200,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-55,0,0,0,-18,0,0,-19,
            0,0,0,0,-151,0,0,0,0,0,
            0,-25,0,0,0,-201,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-60,0,0,-101,0,0,0,0,0,
            0,0,0,0,0,0,-28,0,0,0,
            0,0,-136,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-9,0,
            0,0,0,0,-275,0,0,0,0,0,
            0,0,0,-102,0,0,0,-315,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-165,-8,0,0,-345,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-187,0,0,-183,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-174,0,0,0,
            0,0,0,-215,0,-140,0,-402,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-366,
            0,-30,-33,-311,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-41,
            -47,0,0,0,-178,0,0,0,0,0,
            0,-79,0,0,0,0,0,0,0,0,
            0,0,-119,0,0,0,-196,0,0,0,
            0,-199,0,0,0,-39,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-43,-44,0,
            0,0,0,0,0,0,0,0,0,-395,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-45,-158,0,0,-40,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-154,-155,-152,0,-46,-223,
            0,0,0,-341,0,0,-92,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-354,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-49,0,0,
            0,0,-121,0,-127,0,-163,0,-50,-260,
            -51,0,-168,-250,0,0,0,0,0,-166,
            0,0,0,0,0,-373,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-255,-167,-179,0,0,-192,-170,-393,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-53,0,
            0,0,-96,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-404,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-57,0,-180,0,-125,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-58,0,0,-93,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-177,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-23,0,0,0,-171,0,0,0,-207,
            0,-213,-317,-216,0,-374,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -246,-256,0,0,0,0,-59,-257,-61,-63,
            0,0,0,0,0,-65,0,-318,0,-305,
            -375,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -313,0,-67,-321,0,-406,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-68,0,0,-29,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-258,-370,0,-346,0,-268,0,0,0,
            0,0,-94,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-37,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-54,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -302,0,0,0,0,0,0,-274,-75,0,
            -82,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-97,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-252,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-334,
            0,0,-335,0,0,-367,0,-76,0,0,
            -381,0,-304,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-156,0,
            0,-188,-343,-382,0,0,-383,0,-377,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-77,-388,0,0,0,
            0,0,0,0,-78,0,0,0,0,0,
            -86,-387,0,0,0,0,-87,0,-98,-99,
            0,0,-22,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-100,
            -103,0,-42,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-64,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-66,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-104,-105,-123,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-95,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-106,-107,-109,-111,
            0,-204,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-113,-116,-120,
            -122,-124,-128,-129,-130,-131,0,-132,-133,-135,
            -138,0,0,0,-245,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -141,-142,-143,-148,0,-149,-150,-164,-172,0,
            -175,-310,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-176,-181,-184,
            -189,-190,-191,-193,-197,0,0,-202,-203,-205,
            -206,0,-208,0,-391,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -209,0,0,-217,0,-396,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-218,-220,-221,0,-80,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-224,-226,-227,-228,-229,-230,0,-110,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-159,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-219,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-403,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-231,-232,-269,-233,-214,-234,-235,
            -115,0,0,-236,-237,-238,-239,-240,-241,0,
            -242,-243,-244,0,-247,-249,0,0,-251,0,
            -259,-261,-263,-264,-265,-267,-270,-272,-276,0,
            0,0,0,-277,0,-278,0,0,0,-279,
            -280,-281,-282,0,0,0,0,0,0,-283,
            0,0,0,0,0,0,-134,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-145,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-153,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-169,0,0,-284,-285,-286,
            -287,-288,-289,-290,-291,-292,-293,-294,-296,-297,
            0,-298,-299,-301,-303,-306,-307,-308,-312,-316,
            -319,-320,-322,-323,0,0,0,-324,-325,-326,
            -327,0,0,-328,-329,-330,-331,-332,-333,-336,
            -337,0,-339,-340,0,0,0,0,0,0,
            -173,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-185,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-194,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-195,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-198,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -248,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-253,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-254,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-262,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-273,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -300,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-338,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-69,0,0,-342,-344,-347,-210,-348,
            -349,-126,0,0,-350,-351,-352,-353,0,-355,
            -212,0,0,-356,-357,-358,-359,0,-360,-222,
            0,0,-72,0,0,0,0,0,0,-361,
            -362,-389,0,0,0,0,0,0,-363,0,
            -364,-365,0,0,0,0,0,0,0,-368,
            -369,0,0,0,0,0,0,0,-371,-112,
            0,0,0,0,0,0,0,-211,-271,0,
            0,0,0,0,0,-16,0,0,-20,0,
            0,0,-372,-376,-378,-379,-380,-384,-390,0,
            0,0,-385,0,0,0,0,0,0,-386,
            -392,-394,0,0,-397,-398,0,0,0,-399,
            0,-400,-401,-405,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0
        };
    };
    public final static short baseCheck[] = BaseCheck.baseCheck;
    public final int baseCheck(int index) { return baseCheck[index]; }
    public final static short rhs[] = baseCheck;
    public final int rhs(int index) { return rhs[index]; };

    public interface BaseAction {
        public final static char baseAction[] = {
            113,113,113,113,72,73,73,73,73,73,
            73,114,21,21,21,21,21,80,115,117,
            117,166,166,39,42,42,40,40,35,35,
            35,81,81,36,36,36,36,79,7,7,
            83,120,120,84,121,121,8,122,122,123,
            5,65,85,85,6,6,56,9,9,9,
            9,9,9,9,9,125,125,125,125,128,
            128,129,129,130,126,126,126,126,126,126,
            138,137,137,133,133,139,139,140,140,140,
            140,140,141,141,141,141,141,141,141,141,
            141,142,142,142,142,136,136,136,136,134,
            134,134,134,134,134,134,134,134,134,134,
            134,134,135,135,135,135,135,44,44,44,
            44,86,127,167,167,167,167,167,167,167,
            77,168,168,67,67,67,67,67,67,67,
            24,15,15,15,25,25,59,59,10,10,
            10,10,10,10,10,10,10,10,10,10,
            10,14,14,14,14,14,14,169,60,170,
            170,13,13,45,45,19,91,145,145,92,
            92,61,146,146,93,93,147,147,1,1,
            124,26,26,26,26,26,26,68,68,149,
            149,75,75,27,27,131,131,28,28,78,
            112,111,110,150,150,97,97,98,99,151,
            152,29,29,148,89,89,89,119,119,116,
            116,22,22,96,96,87,87,153,153,153,
            82,82,101,101,171,171,95,95,90,90,
            62,62,154,154,154,154,155,155,57,57,
            57,57,57,70,70,156,156,156,48,48,
            3,3,102,102,94,94,158,158,143,143,
            66,66,103,157,157,12,12,118,104,104,
            104,104,38,41,41,41,41,41,41,37,
            37,17,31,74,30,30,30,32,64,64,
            64,64,64,64,132,132,33,144,144,34,
            2,172,172,160,160,23,23,23,23,23,
            23,23,23,11,11,11,11,11,11,11,
            11,11,11,11,11,11,11,11,11,11,
            4,46,46,46,43,106,106,63,63,69,
            69,16,49,50,51,52,53,54,54,47,
            47,47,47,47,47,161,161,55,88,88,
            58,58,163,105,159,159,159,100,71,71,
            71,107,107,76,20,108,108,162,162,18,
            18,164,164,109,8976,1119,718,1011,159,54,
            161,165,166,162,176,160,163,164,455,1207,
            8895,1649,915,4455,582,342,9554,33,341,1842,
            340,337,339,338,9007,5193,297,336,335,26,
            1811,8924,8981,8936,1813,8995,1843,9237,1119,718,
            1011,159,54,161,165,166,162,176,160,163,
            164,455,1207,1841,1649,915,9133,582,342,9025,
            33,341,1842,340,337,339,338,9244,9127,742,
            336,335,26,1811,5193,11,260,1813,317,2003,
            8907,1119,718,1011,159,54,161,165,166,162,
            176,160,163,164,455,966,1841,894,314,315,
            582,342,175,33,341,8889,340,337,339,338,
            224,225,226,336,335,26,1811,444,5193,371,
            1813,1478,1812,9214,1119,718,1163,538,54,388,
            9214,330,718,445,245,8952,222,8907,1119,718,
            1011,159,54,161,165,166,162,176,160,163,
            164,455,966,6671,330,718,600,582,342,9255,
            33,341,3716,340,337,339,338,9439,9173,1379,
            336,335,26,1811,237,5193,371,1813,37,1812,
            5193,131,313,286,8960,489,915,9435,23,9264,
            2349,391,993,1790,8907,1119,718,1011,159,54,
            161,165,166,162,176,160,163,164,455,966,
            9431,1782,9022,8967,582,342,8891,33,341,1816,
            340,337,339,338,1762,487,934,336,335,26,
            1811,9041,494,140,1813,436,1812,9189,538,354,
            1,4,5,6,7,8,9,10,479,243,
            290,8907,1119,718,1011,159,54,161,165,166,
            162,176,160,163,164,455,966,9436,5193,51,
            1818,582,342,5194,33,341,9098,340,337,339,
            338,430,8906,765,336,335,26,1811,5193,810,
            807,1813,9098,1812,1789,42,5193,50,752,489,
            915,55,772,587,390,9602,220,374,9246,1119,
            718,1011,159,54,161,165,166,162,176,160,
            163,164,455,966,5193,810,807,9127,582,342,
            9439,33,341,52,340,337,339,338,5193,51,
            390,336,335,26,1811,9281,525,9170,1813,1848,
            1812,45,9103,1724,2,4,5,6,7,8,
            9,10,212,915,266,8907,1119,718,1011,159,
            54,161,165,166,162,176,160,163,164,455,
            966,1814,630,9134,725,582,342,48,33,341,
            743,340,337,339,338,9105,403,1817,336,335,
            26,1811,9137,53,2139,2012,8907,1119,718,1011,
            159,54,161,165,166,162,176,160,163,164,
            455,966,5193,371,487,9349,582,342,372,33,
            341,44,340,337,339,338,992,9044,488,336,
            335,27,1811,9202,1119,718,1011,159,54,161,
            165,166,162,176,160,163,164,455,966,5193,
            371,292,175,582,342,9679,34,341,687,340,
            337,339,338,1115,9349,488,336,335,9135,1119,
            718,1011,159,54,161,165,166,162,176,160,
            163,164,455,2355,9604,9244,2024,2358,9373,1119,
            718,1011,159,54,161,165,166,162,176,160,
            163,164,455,1759,9607,1649,915,8888,1999,718,
            600,368,1116,194,184,310,314,315,310,314,
            315,412,604,309,326,803,309,9092,1119,718,
            1163,369,54,1780,8149,2017,8914,2357,9305,1119,
            718,1011,159,54,161,165,166,162,176,160,
            163,164,455,2437,271,1649,915,183,411,195,
            5195,196,2976,9120,9403,1119,718,1011,159,54,
            161,165,166,162,176,160,163,164,455,2015,
            9545,5193,1647,191,184,9214,1119,718,1163,2347,
            54,389,9026,67,310,314,315,1641,402,192,
            2215,1603,309,9214,1119,718,1163,9613,54,388,
            1411,204,9065,822,494,2348,5932,1119,718,1011,
            159,54,161,165,166,162,168,160,163,164,
            1914,243,2001,65,66,68,69,70,1,8252,
            74,75,76,77,78,79,83,84,85,86,
            9413,1119,718,1011,159,54,161,165,166,162,
            176,160,163,164,455,2355,8920,5193,51,183,
            5932,1119,718,1011,159,54,161,165,166,162,
            167,160,163,164,2464,9554,9590,9223,298,8909,
            9629,1819,72,29,9755,191,184,5932,1119,718,
            1011,159,54,161,165,166,162,174,160,163,
            164,190,9377,1119,718,1011,159,54,161,165,
            166,162,176,160,163,164,455,2437,9546,1649,
            915,364,52,5193,371,7410,371,5193,371,9547,
            9474,9549,187,9329,9228,260,260,316,302,1641,
            9604,1839,1853,2418,175,365,9136,1119,718,1011,
            159,54,161,165,166,162,176,160,163,164,
            455,2355,9675,9604,9130,183,203,9111,9357,9394,
            1119,718,1011,159,54,161,165,166,162,176,
            160,163,164,455,2437,2463,1649,915,364,749,
            1818,194,184,5932,1119,718,1011,159,54,161,
            165,166,162,176,160,163,164,815,2436,487,
            270,30,365,9414,1119,718,1011,159,54,161,
            165,166,162,176,160,163,164,455,2355,218,
            1120,2215,183,269,885,227,9301,195,8992,197,
            2975,1578,1626,1011,159,54,161,165,166,162,
            176,160,163,164,455,1022,1635,9379,191,184,
            5932,1119,718,1011,159,54,161,165,166,162,
            173,160,163,164,190,2436,9238,1119,718,1011,
            159,54,161,165,166,162,176,160,163,164,
            455,1670,9244,1649,915,1818,9024,330,718,964,
            9358,1894,9359,9209,9369,188,9801,1119,718,1011,
            159,54,161,165,166,162,176,160,163,164,
            455,2355,310,314,315,364,310,314,315,803,
            309,9374,9676,1344,309,1893,14,9551,9676,9451,
            9232,487,13,487,334,487,9283,2364,9209,368,
            9721,9801,1119,718,1011,159,54,161,165,166,
            162,176,160,163,164,455,2355,1649,915,369,
            364,9349,487,9344,9209,2451,8956,1119,718,1011,
            159,54,161,165,166,162,176,160,163,164,
            455,2355,2365,9482,368,183,1524,1119,718,1011,
            159,54,161,165,166,162,176,160,163,164,
            455,1413,9676,9791,369,9554,12,9094,2366,1455,
            2452,191,184,5932,1119,718,1011,159,54,161,
            165,166,162,172,160,163,164,193,757,1578,
            1626,1011,159,54,161,165,166,162,176,160,
            163,164,455,1022,1635,8912,1119,718,1011,159,
            54,161,165,166,162,176,160,163,164,455,
            1670,9228,1649,915,1818,260,19,312,9343,8970,
            1650,9553,1119,718,1011,159,54,161,165,166,
            162,176,160,163,164,455,1788,5932,1119,718,
            1011,159,54,161,165,166,162,176,160,163,
            164,1117,1386,1433,8912,1119,718,1011,159,54,
            161,165,166,162,176,160,163,164,455,2015,
            9676,1649,915,9676,16,1818,9676,15,8929,2114,
            206,9209,333,8912,1119,718,1011,159,54,161,
            165,166,162,176,160,163,164,455,2015,9244,
            1649,915,9244,9391,9209,228,217,9209,2143,9806,
            1119,718,1011,159,54,161,165,166,162,176,
            160,163,164,455,2355,2455,8933,9808,364,310,
            314,315,310,314,315,9008,1340,309,1519,1371,
            309,9020,9676,1785,487,48,205,9559,2456,9560,
            9561,2460,368,9109,1119,718,1011,159,54,161,
            165,166,162,176,160,163,164,455,1229,200,
            8938,9562,370,758,1119,718,1011,159,54,161,
            165,166,162,176,160,163,164,455,767,2238,
            1119,718,1011,159,54,161,165,166,162,176,
            160,163,164,455,651,8912,1119,718,1011,159,
            54,161,165,166,162,176,160,163,164,455,
            1759,2462,1649,915,9327,9511,9576,1119,718,1011,
            159,54,161,165,166,162,176,160,163,164,
            455,1838,5932,1119,718,1011,159,54,161,165,
            166,162,171,160,163,164,41,9563,9483,9199,
            9300,407,3818,1119,718,1011,159,54,161,165,
            166,162,176,160,163,164,455,2015,9179,9565,
            860,9566,9417,759,9568,9577,9578,2014,9457,9579,
            9582,9583,293,632,209,4456,1119,718,1011,159,
            54,161,165,166,162,176,160,163,164,455,
            2015,5220,9247,9589,9584,607,9591,9595,9601,9445,
            1894,9603,3818,1119,718,1011,159,54,161,165,
            166,162,176,160,163,164,455,2015,9463,9245,
            9468,9605,9610,9335,9158,9047,1758,2014,9614,9035,
            9616,9478,2013,9624,2109,9390,1119,718,1011,159,
            54,161,165,166,162,176,160,163,164,455,
            1759,9449,1649,915,2977,1821,5296,1119,718,1011,
            159,54,161,165,166,162,176,160,163,164,
            455,2355,9485,9636,9627,364,9552,1119,718,1011,
            159,54,161,165,166,162,176,160,163,164,
            455,1229,2346,2339,9641,9635,9637,9649,9653,366,
            2238,1119,718,1011,159,54,161,165,166,162,
            176,160,163,164,455,1413,2238,1119,718,1011,
            159,54,161,165,166,162,176,160,163,164,
            455,651,9576,1119,718,1011,159,54,161,165,
            166,162,176,160,163,164,455,1838,9812,1119,
            718,1011,159,54,161,165,166,162,176,160,
            163,164,455,1838,9655,9657,9315,9658,9625,9260,
            9393,2236,810,1778,9670,9671,9672,9642,9673,9295,
            20,9447,9490,9466,408,3002,9644,2410,494,9203,
            494,9498,9659,9680,4557,9501,9053,9677,9678,9681,
            210,310,314,315,9682,747,9688,747,1208,309,
            9319,9429,9638,9690,1115,377,230,377,1173,294,
            9693,384,381,383,380,382,379,2238,1119,718,
            1011,159,54,161,165,166,162,176,160,163,
            164,455,1840,2238,1119,718,1011,159,54,161,
            165,166,162,176,160,163,164,455,1849,2238,
            1119,718,1011,159,54,161,165,166,162,176,
            160,163,164,455,1851,3715,810,1778,9694,9695,
            9697,9698,9699,9701,9703,9708,9709,9710,9711,9712,
            9473,2410,9406,9714,9716,9410,9508,9726,9728,9421,
            9734,9729,9733,9735,9738,310,314,315,9737,9740,
            9741,9742,1342,309,9747,9495,9512,9516,9750,9745,
            8957,9513,1173,9751,9746,384,381,383,380,382,
            379,2238,1119,718,1011,159,54,161,165,166,
            162,176,160,163,164,455,1892,2238,1119,718,
            1011,159,54,161,165,166,162,176,160,163,
            164,455,2002,2238,1119,718,1011,159,54,161,
            165,166,162,176,160,163,164,455,1174,2238,
            1119,718,1011,159,54,161,165,166,162,176,
            160,163,164,455,2009,9292,1119,718,1011,159,
            54,161,165,166,162,176,160,163,164,455,
            2011,2238,1119,718,1011,159,54,161,165,166,
            162,176,160,163,164,455,2112,2238,1119,718,
            1011,159,54,161,165,166,162,176,160,163,
            164,455,1511,2238,1119,718,1011,159,54,161,
            165,166,162,176,160,163,164,455,2115,2238,
            1119,718,1011,159,54,161,165,166,162,176,
            160,163,164,455,2116,2238,1119,718,1011,159,
            54,161,165,166,162,176,160,163,164,455,
            2119,2238,1119,718,1011,159,54,161,165,166,
            162,176,160,163,164,455,2141,2238,1119,718,
            1011,159,54,161,165,166,162,176,160,163,
            164,455,2401,1497,810,1778,9759,9765,9749,2237,
            9752,9753,1497,810,1778,9524,9754,9517,9518,2410,
            9757,1497,810,1778,9768,9770,9771,9758,2410,9775,
            4454,810,1778,9092,1119,718,1163,2410,54,1780,
            9761,9782,9159,1119,718,1163,2410,54,1780,9763,
            633,9783,9787,384,381,383,380,382,379,1278,
            9789,9534,384,381,383,380,382,379,1457,9793,
            8890,384,381,383,380,382,379,1518,8890,9625,
            384,381,383,380,382,379,5193,810,807,5193,
            810,807,494,9796,9804,9527,9528,9425,9803,9810,
            494,494,390,9805,401,390,223,225,226,747,
            9807,9530,9531,401,1760,9811,9814,747,747,282,
            9815,494,5934,9537,9544,3008,3008,282,378,3008,
            3008,3008,3008,750,3008,3008,3008,3008,747,3008,
            1781,3008,229,3008,636,3008,3008,609,373,1781,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,433,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,387,1204,3008,3008,3008,3008,3008,3008,
            376,3008,0,3207,281,0,3206,281,0,3249,
            242,0,246,242,0,3244,234,0,3243,234,
            0,3178,3206,281,0,3177,3206,281,0,1010,
            3206,281,0,1673,3206,281,0,1069,3206,281,
            0,1096,3206,281,0,3367,3206,281,0,3366,
            3206,281,0,3365,3206,281,0,3364,3206,281,
            0,3363,3206,281,0,573,3206,281,0,3361,
            3206,281,0,3360,3206,281,0,3359,3206,281,
            0,1158,3206,281,0,1169,3206,281,0,1171,
            3206,281,0,3352,3206,281,0,3351,3206,281,
            0,244,242,0,285,543,0,281,3207,0,
            281,3206,0,3178,281,3206,0,3177,281,3206,
            0,1010,281,3206,0,1673,281,3206,0,1069,
            281,3206,0,1096,281,3206,0,3367,281,3206,
            0,3366,281,3206,0,3365,281,3206,0,3364,
            281,3206,0,3363,281,3206,0,573,281,3206,
            0,3361,281,3206,0,3360,281,3206,0,3359,
            281,3206,0,1158,281,3206,0,1169,281,3206,
            0,1171,281,3206,0,3352,281,3206,0,3351,
            281,3206,0,279,857,0,557,3206,281,0,
            61,62,0,1300,153,0,3157,153,0,3156,
            153,0,3155,153,0,3154,153,0,3153,153,
            0,3152,153,0,3151,153,0,1705,410,0,
            879,3206,281,0,410,3206,281,0,1779,3206,
            0,1726,410,0,330,371,0,1784,261,0,
            1786,3206,281,0,863,3206,281,0,1791,3206,
            281,0,154,3166,0,283,242,0,452,3206,
            0,1653,3206,0,280,3207,0,280,3206,0,
            170,233,0,414,410,0,1300,152,0,3157,
            152,0,3156,152,0,3155,152,0,3154,152,
            0,3153,152,0,3152,152,0,3151,152,0,
            1300,151,0,3157,151,0,3156,151,0,3155,
            151,0,3154,151,0,3153,151,0,3152,151,
            0,3151,151,0,452,3206,281,0,1653,3206,
            281,0,3088,3206,281,0,3090,3206,281,0,
            3089,3206,281,0,1915,3206,281,0,1916,3206,
            281,0,1917,3206,281,0,1918,3206,281,0,
            1984,3206,281,0,1985,3206,281,0,1987,3206,
            281,0,1989,3206,281,0,1990,3206,281,0,
            3112,3206,281,0,3111,3206,281,0,3110,3206,
            281,0,3109,3206,281,0,1994,3206,281,0,
            1995,3206,281,0,1996,3206,281,0,1997,3206,
            281,0,3097,3206,281,0,1998,3206,281,0,
            1372,3206,281,0,1378,3206,281,0,1452,3206,
            281,0,404,2110,0,857,242,0,279,242,
            0,157,2140,0,2350,3206,281,0,2351,3206,
            281,0,2356,3206,281,0,918,410,0,410,
            452,3206,281,0,410,1653,3206,281,0,364,
            183,0,185,3166,0,1855,410,0
        };
    };
    public final static char baseAction[] = BaseAction.baseAction;
    public final int baseAction(int index) { return baseAction[index]; }
    public final static char lhs[] = baseAction;
    public final int lhs(int index) { return lhs[index]; };

    public interface TermCheck0 {
        public final static char termCheck0[] = {0,
            0,1,2,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,0,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,92,93,94,95,96,97,98,99,
            100,101,102,103,104,105,106,107,108,109,
            110,111,112,113,114,115,116,117,118,119,
            120,121,122,123,124,125,126,127,128,129,
            130,131,132,133,134,135,136,137,138,139,
            140,141,142,143,144,145,146,147,148,149,
            150,151,152,153,154,155,156,157,158,159,
            160,161,162,163,164,165,166,167,168,169,
            170,171,172,173,174,175,176,177,178,179,
            180,181,182,183,184,185,186,187,188,189,
            190,191,192,193,194,195,196,197,198,199,
            200,201,202,203,204,205,206,207,208,209,
            210,211,212,213,214,215,216,217,218,219,
            220,221,222,223,224,225,226,227,228,229,
            230,231,232,233,234,235,236,237,238,239,
            240,241,242,243,244,245,246,247,248,249,
            250,251,252,253,254,255,256,257,258,259,
            260,261,262,263,264,265,266,267,268,269,
            270,271,272,273,274,275,276,277,278,279,
            280,281,282,283,284,285,286,287,288,289,
            290,291,292,293,294,295,296,297,298,299,
            300,301,302,303,304,305,306,307,308,309,
            310,311,312,313,314,315,316,317,318,319,
            320,321,322,323,324,325,326,327,328,329,
            330,331,332,333,334,335,336,337,338,339,
            340,341,342,343,344,345,346,347,348,349,
            350,351,352,353,354,355,356,357,358,359,
            360,361,362,363,364,365,366,367,368,369,
            370,371,372,373,374,375,376,377,378,379,
            380,381,382,383,384,385,386,387,388,389,
            390,391,392,393,394,395,396,397,398,399,
            400,401,402,403,404,405,406,407,408,409,
            410,411,412,413,414,415,416,417,418,419,
            420,421,422,423,424,425,426,427,428,429,
            430,431,432,433,434,435,436,437,438,439,
            440,441,442,443,444,445,446,447,448,449,
            450,451,452,453,454,455,456,457,458,459,
            460,461,462,463,464,465,466,467,468,469,
            470,471,472,473,474,475,476,477,478,479,
            480,481,482,483,484,485,486,487,488,489,
            490,491,492,493,494,495,496,497,498,499,
            500,501,502,503,504,505,506,507,508,509,
            510,511,512,513,514,515,516,517,518,519,
            520,521,522,523,524,525,526,527,528,529,
            530,531,532,533,534,535,536,537,538,539,
            540,541,542,543,544,545,546,547,548,549,
            550,551,552,553,554,555,556,557,558,559,
            560,561,562,563,564,565,566,567,568,569,
            570,571,572,573,574,575,576,577,578,579,
            580,581,582,583,584,585,586,587,588,589,
            590,591,592,593,594,595,596,597,598,599,
            600,601,602,603,604,605,606,607,608,609,
            610,611,612,613,614,615,616,617,618,619,
            620,621,622,623,624,625,626,627,628,629,
            630,631,632,633,634,635,636,637,638,639,
            640,641,642,643,644,645,646,647,648,649,
            650,651,652,653,654,655,656,657,658,659,
            660,661,662,663,664,665,666,667,668,669,
            670,671,672,673,674,675,676,677,678,679,
            680,681,682,683,684,685,686,687,688,689,
            690,691,692,693,694,695,696,697,698,699,
            700,701,702,703,704,705,706,707,708,709,
            710,711,712,713,714,715,716,717,718,719,
            720,721,722,723,724,725,726,727,728,729,
            730,731,732,733,734,735,736,737,738,739,
            740,0,0,743,744,745,746,747,0,1,
            2,0,11,753,754,755,0,0,0,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,26,28,29,30,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,756,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,75,76,77,78,79,80,81,82,83,
            84,85,86,87,88,89,90,91,92,93,
            94,95,96,97,98,99,100,101,102,0,
            104,105,106,107,108,109,110,111,112,113,
            114,115,116,117,118,119,120,121,122,123,
            124,125,126,127,128,129,130,131,132,133,
            134,135,136,137,138,139,140,141,142,143,
            144,145,146,147,148,149,150,151,152,153,
            154,155,156,157,158,159,160,161,162,163,
            164,165,166,167,168,169,170,171,172,173,
            174,175,176,177,178,179,180,181,182,183,
            184,185,186,187,188,189,190,191,192,193,
            194,195,196,197,198,199,200,201,202,203,
            204,205,206,207,208,209,210,211,212,213,
            214,215,216,217,218,219,220,221,222,223,
            224,225,226,227,228,229,230,231,232,233,
            234,235,236,237,238,239,240,241,242,243,
            244,245,246,247,248,249,250,251,252,253,
            254,255,256,257,258,259,260,261,262,263,
            264,265,266,267,268,269,270,271,272,273,
            274,275,276,277,278,279,280,281,282,283,
            284,285,286,287,288,289,290,291,292,293,
            294,295,296,297,298,299,300,301,302,303,
            304,305,306,307,308,309,310,311,312,313,
            314,315,316,317,318,319,320,321,322,323,
            324,325,326,327,328,329,330,331,332,333,
            334,335,336,337,338,339,340,341,342,343,
            344,345,346,347,348,349,350,351,352,353,
            354,355,356,357,358,359,360,361,362,363,
            364,365,366,367,368,369,370,371,372,373,
            374,375,376,377,378,379,380,381,382,383,
            384,385,386,387,388,389,390,391,392,393,
            394,395,396,397,398,399,400,401,402,403,
            404,405,406,407,408,409,410,411,412,413,
            414,415,416,417,418,419,420,421,422,423,
            424,425,426,427,428,429,430,431,432,433,
            434,435,436,437,438,439,440,441,442,443,
            444,445,446,447,448,449,450,451,452,453,
            454,455,456,457,458,459,460,461,462,463,
            464,465,466,467,468,469,470,471,472,473,
            474,475,476,477,478,479,480,481,482,483,
            484,485,486,487,488,489,490,491,492,493,
            494,495,496,497,498,499,500,501,502,503,
            504,505,506,507,508,509,510,511,512,513,
            514,515,516,517,518,519,520,521,522,523,
            524,525,526,527,528,529,530,531,532,533,
            534,535,536,537,538,539,540,541,542,543,
            544,545,546,547,548,549,550,551,552,553,
            554,555,556,557,558,559,560,561,562,563,
            564,565,566,567,568,569,570,571,572,573,
            574,575,576,577,578,579,580,581,582,583,
            584,585,586,587,588,589,590,591,592,593,
            594,595,596,597,598,599,600,601,602,603,
            604,605,606,607,608,609,610,611,612,613,
            614,615,616,617,618,619,620,621,622,623,
            624,625,626,627,628,629,630,631,632,633,
            634,635,636,637,638,639,640,641,642,643,
            644,645,646,647,648,649,650,651,652,653,
            654,655,656,657,658,659,660,661,662,663,
            664,665,666,667,668,669,670,671,672,673,
            674,675,676,677,678,679,680,681,682,683,
            684,685,686,687,688,689,690,691,692,693,
            694,695,696,697,698,699,700,701,702,703,
            704,705,706,707,708,709,710,711,712,713,
            714,715,716,717,718,719,720,721,722,723,
            724,725,726,727,728,729,730,731,732,733,
            734,735,736,737,738,739,0,739,756,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,0,28,29,30,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,75,76,77,78,79,80,81,82,83,
            84,85,86,87,88,89,90,91,92,93,
            94,95,96,97,98,99,100,101,102,740,
            104,105,106,107,108,109,110,111,112,113,
            114,115,116,117,118,119,120,121,122,123,
            124,125,126,127,128,129,130,131,132,133,
            134,135,136,137,138,139,140,141,142,143,
            144,145,146,147,148,149,150,151,152,153,
            154,155,156,157,158,159,160,161,162,163,
            164,165,166,167,168,169,170,171,172,173,
            174,175,176,177,178,179,180,181,182,183,
            184,185,186,187,188,189,190,191,192,193,
            194,195,196,197,198,199,200,201,202,203,
            204,205,206,207,208,209,210,211,212,213,
            214,215,216,217,218,219,220,221,222,223,
            224,225,226,227,228,229,230,231,232,233,
            234,235,236,237,238,239,240,241,242,243,
            244,245,246,247,248,249,250,251,252,253,
            254,255,256,257,258,259,260,261,262,263,
            264,265,266,267,268,269,270,271,272,273,
            274,275,276,277,278,279,280,281,282,283,
            284,285,286,287,288,289,290,291,292,293,
            294,295,296,297,298,299,300,301,302,303,
            304,305,306,307,308,309,310,311,312,313,
            314,315,316,317,318,319,320,321,322,323,
            324,325,326,327,328,329,330,331,332,333,
            334,335,336,337,338,339,340,341,342,343,
            344,345,346,347,348,349,350,351,352,353,
            354,355,356,357,358,359,360,361,362,363,
            364,365,366,367,368,369,370,371,372,373,
            374,375,376,377,378,379,380,381,382,383,
            384,385,386,387,388,389,390,391,392,393,
            394,395,396,397,398,399,400,401,402,403,
            404,405,406,407,408,409,410,411,412,413,
            414,415,416,417,418,419,420,421,422,423,
            424,425,426,427,428,429,430,431,432,433,
            434,435,436,437,438,439,440,441,442,443,
            444,445,446,447,448,449,450,451,452,453,
            454,455,456,457,458,459,460,461,462,463,
            464,465,466,467,468,469,470,471,472,473,
            474,475,476,477,478,479,480,481,482,483,
            484,485,486,487,488,489,490,491,492,493,
            494,495,496,497,498,499,500,501,502,503,
            504,505,506,507,508,509,510,511,512,513,
            514,515,516,517,518,519,520,521,522,523,
            524,525,526,527,528,529,530,531,532,533,
            534,535,536,537,538,539,540,541,542,543,
            544,545,546,547,548,549,550,551,552,553,
            554,555,556,557,558,559,560,561,562,563,
            564,565,566,567,568,569,570,571,572,573,
            574,575,576,577,578,579,580,581,582,583,
            584,585,586,587,588,589,590,591,592,593,
            594,595,596,597,598,599,600,601,602,603,
            604,605,606,607,608,609,610,611,612,613,
            614,615,616,617,618,619,620,621,622,623,
            624,625,626,627,628,629,630,631,632,633,
            634,635,636,637,638,639,640,641,642,643,
            644,645,646,647,648,649,650,651,652,653,
            654,655,656,657,658,659,660,661,662,663,
            664,665,666,667,668,669,670,671,672,673,
            674,675,676,677,678,679,680,681,682,683,
            684,685,686,687,688,689,690,691,692,693,
            694,695,696,697,698,699,700,701,702,703,
            704,705,706,707,708,709,710,711,712,713,
            714,715,716,717,718,719,720,721,722,723,
            724,725,726,727,728,729,730,731,732,733,
            734,735,736,737,738,0,0,0,3,4,
            5,6,7,8,9,10,11,12,13,14,
            15,16,17,18,19,20,21,22,23,24,
            25,26,26,28,29,30,31,32,33,34,
            35,36,37,38,39,40,41,42,43,44,
            45,46,47,48,49,50,51,52,53,54,
            55,56,57,58,59,60,61,62,63,64,
            65,66,67,68,69,70,71,72,73,74,
            75,76,77,78,79,80,81,82,83,84,
            85,86,87,88,89,90,91,92,93,94,
            95,96,97,98,99,100,101,102,0,104,
            105,106,107,108,109,110,111,112,113,114,
            115,116,117,118,119,120,121,122,123,124,
            125,126,127,128,129,130,131,132,133,134,
            135,136,137,138,139,140,141,142,143,144,
            145,146,147,148,149,150,151,152,153,154,
            155,156,157,158,159,160,161,162,163,164,
            165,166,167,168,169,170,171,172,173,174,
            175,176,177,178,179,180,181,182,183,184,
            185,186,187,188,189,190,191,192,193,194,
            195,196,197,198,199,200,201,202,203,204,
            205,206,207,208,209,210,211,212,213,214,
            215,216,217,218,219,220,221,222,223,224,
            225,226,227,228,229,230,231,232,233,234,
            235,236,237,238,239,240,241,242,243,244,
            245,246,247,248,249,250,251,252,253,254,
            255,256,257,258,259,260,261,262,263,264,
            265,266,267,268,269,270,271,272,273,274,
            275,276,277,278,279,280,281,282,283,284,
            285,286,287,288,289,290,291,292,293,294,
            295,296,297,298,299,300,301,302,303,304,
            305,306,307,308,309,310,311,312,313,314,
            315,316,317,318,319,320,321,322,323,324,
            325,326,327,328,329,330,331,332,333,334,
            335,336,337,338,339,340,341,342,343,344,
            345,346,347,348,349,350,351,352,353,354,
            355,356,357,358,359,360,361,362,363,364,
            365,366,367,368,369,370,371,372,373,374,
            375,376,377,378,379,380,381,382,383,384,
            385,386,387,388,389,390,391,392,393,394,
            395,396,397,398,399,400,401,402,403,404,
            405,406,407,408,409,410,411,412,413,414,
            415,416,417,418,419,420,421,422,423,424,
            425,426,427,428,429,430,431,432,433,434,
            435,436,437,438,439,440,441,442,443,444,
            445,446,447,448,449,450,451,452,453,454,
            455,456,457,458,459,460,461,462,463,464,
            465,466,467,468,469,470,471,472,473,474,
            475,476,477,478,479,480,481,482,483,484,
            485,486,487,488,489,490,491,492,493,494,
            495,496,497,498,499,500,501,502,503,504,
            505,506,507,508,509,510,511,512,513,514,
            515,516,517,518,519,520,521,522,523,524,
            525,526,527,528,529,530,531,532,533,534,
            535,536,537,538,539,540,541,542,543,544,
            545,546,547,548,549,550,551,552,553,554,
            555,556,557,558,559,560,561,562,563,564,
            565,566,567,568,569,570,571,572,573,574,
            575,576,577,578,579,580,581,582,583,584,
            585,586,587,588,589,590,591,592,593,594,
            595,596,597,598,599,600,601,602,603,604,
            605,606,607,608,609,610,611,612,613,614,
            615,616,617,618,619,620,621,622,623,624,
            625,626,627,628,629,630,631,632,633,634,
            635,636,637,638,639,640,641,642,643,644,
            645,646,647,648,649,650,651,652,653,654,
            655,656,657,658,659,660,661,662,663,664,
            665,666,667,668,669,670,671,672,673,674,
            675,676,677,678,679,680,681,682,683,684,
            685,686,687,688,689,690,691,692,693,694,
            695,696,697,698,699,700,701,702,703,704,
            705,706,707,708,709,710,711,712,713,714,
            715,716,717,718,719,720,721,722,723,724,
            725,726,727,728,729,730,731,732,733,734,
            735,736,737,738,0,0,0,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,0,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,46,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,70,71,72,73,74,75,
            76,77,78,79,80,81,82,83,84,85,
            86,87,88,89,90,91,92,93,94,95,
            96,97,98,99,100,101,102,739,104,105,
            106,107,108,109,110,111,112,113,114,115,
            116,117,118,119,120,121,122,123,124,125,
            126,127,128,129,130,131,132,133,134,135,
            136,137,138,139,140,141,142,143,144,145,
            146,147,148,149,150,151,152,153,154,155,
            156,157,158,159,160,161,162,163,164,165,
            166,167,168,169,170,171,172,173,174,175,
            176,177,178,179,180,181,182,183,184,185,
            186,187,188,189,190,191,192,193,194,195,
            196,197,198,199,200,201,202,203,204,205,
            206,207,208,209,210,211,212,213,214,215,
            216,217,218,219,220,221,222,223,224,225,
            226,227,228,229,230,231,232,233,234,235,
            236,237,238,239,240,241,242,243,244,245,
            246,247,248,249,250,251,252,253,254,255,
            256,257,258,259,260,261,262,263,264,265,
            266,267,268,269,270,271,272,273,274,275,
            276,277,278,279,280,281,282,283,284,285,
            286,287,288,289,290,291,292,293,294,295,
            296,297,298,299,300,301,302,303,304,305,
            306,307,308,309,310,311,312,313,314,315,
            316,317,318,319,320,321,322,323,324,325,
            326,327,328,329,330,331,332,333,334,335,
            336,337,338,339,340,341,342,343,344,345,
            346,347,348,349,350,351,352,353,354,355,
            356,357,358,359,360,361,362,363,364,365,
            366,367,368,369,370,371,372,373,374,375,
            376,377,378,379,380,381,382,383,384,385,
            386,387,388,389,390,391,392,393,394,395,
            396,397,398,399,400,401,402,403,404,405,
            406,407,408,409,410,411,412,413,414,415,
            416,417,418,419,420,421,422,423,424,425,
            426,427,428,429,430,431,432,433,434,435,
            436,437,438,439,440,441,442,443,444,445,
            446,447,448,449,450,451,452,453,454,455,
            456,457,458,459,460,461,462,463,464,465,
            466,467,468,469,470,471,472,473,474,475,
            476,477,478,479,480,481,482,483,484,485,
            486,487,488,489,490,491,492,493,494,495,
            496,497,498,499,500,501,502,503,504,505,
            506,507,508,509,510,511,512,513,514,515,
            516,517,518,519,520,521,522,523,524,525,
            526,527,528,529,530,531,532,533,534,535,
            536,537,538,539,540,541,542,543,544,545,
            546,547,548,549,550,551,552,553,554,555,
            556,557,558,559,560,561,562,563,564,565,
            566,567,568,569,570,571,572,573,574,575,
            576,577,578,579,580,581,582,583,584,585,
            586,587,588,589,590,591,592,593,594,595,
            596,597,598,599,600,601,602,603,604,605,
            606,607,608,609,610,611,612,613,614,615,
            616,617,618,619,620,621,622,623,624,625,
            626,627,628,629,630,631,632,633,634,635,
            636,637,638,639,640,641,642,643,644,645,
            646,647,648,649,650,651,652,653,654,655,
            656,657,658,659,660,661,662,663,664,665,
            666,667,668,669,670,671,672,673,674,675,
            676,677,678,679,680,681,682,683,684,685,
            686,687,688,689,690,691,692,693,694,695,
            696,697,698,699,700,701,702,703,704,705,
            706,707,708,709,710,711,712,713,714,715,
            716,717,718,719,720,721,722,723,724,725,
            726,727,728,729,730,731,732,733,734,735,
            736,737,738,739,0,0,740,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,740,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,70,71,72,73,74,75,
            76,77,78,79,80,81,82,83,84,85,
            86,87,88,89,90,91,92,93,94,95,
            96,97,98,99,100,101,102,0,104,105,
            106,107,108,109,110,111,112,113,114,115,
            116,117,118,119,120,121,122,123,124,125,
            126,127,128,129,130,131,132,133,134,135,
            136,137,138,139,140,141,142,143,144,145,
            146,147,148,149,150,151,152,153,154,155,
            156,157,158,159,160,161,162,163,164,165,
            166,167,168,169,170,171,172,173,174,175,
            176,177,178,179,180,181,182,183,184,185,
            186,187,188,189,190,191,192,193,194,195,
            196,197,198,199,200,201,202,203,204,205,
            206,207,208,209,210,211,212,213,214,215,
            216,217,218,219,220,221,222,223,224,225,
            226,227,228,229,230,231,232,233,234,235,
            236,237,238,239,240,241,242,243,244,245,
            246,247,248,249,250,251,252,253,254,255,
            256,257,258,259,260,261,262,263,264,265,
            266,267,268,269,270,271,272,273,274,275,
            276,277,278,279,280,281,282,283,284,285,
            286,287,288,289,290,291,292,293,294,295,
            296,297,298,299,300,301,302,303,304,305,
            306,307,308,309,310,311,312,313,314,315,
            316,317,318,319,320,321,322,323,324,325,
            326,327,328,329,330,331,332,333,334,335,
            336,337,338,339,340,341,342,343,344,345,
            346,347,348,349,350,351,352,353,354,355,
            356,357,358,359,360,361,362,363,364,365,
            366,367,368,369,370,371,372,373,374,375,
            376,377,378,379,380,381,382,383,384,385,
            386,387,388,389,390,391,392,393,394,395,
            396,397,398,399,400,401,402,403,404,405,
            406,407,408,409,410,411,412,413,414,415,
            416,417,418,419,420,421,422,423,424,425,
            426,427,428,429,430,431,432,433,434,435,
            436,437,438,439,440,441,442,443,444,445,
            446,447,448,449,450,451,452,453,454,455,
            456,457,458,459,460,461,462,463,464,465,
            466,467,468,469,470,471,472,473,474,475,
            476,477,478,479,480,481,482,483,484,485,
            486,487,488,489,490,491,492,493,494,495,
            496,497,498,499,500,501,502,503,504,505,
            506,507,508,509,510,511,512,513,514,515,
            516,517,518,519,520,521,522,523,524,525,
            526,527,528,529,530,531,532,533,534,535,
            536,537,538,539,540,541,542,543,544,545,
            546,547,548,549,550,551,552,553,554,555,
            556,557,558,559,560,561,562,563,564,565,
            566,567,568,569,570,571,572,573,574,575,
            576,577,578,579,580,581,582,583,584,585,
            586,587,588,589,590,591,592,593,594,595,
            596,597,598,599,600,601,602,603,604,605,
            606,607,608,609,610,611,612,613,614,615,
            616,617,618,619,620,621,622,623,624,625,
            626,627,628,629,630,631,632,633,634,635,
            636,637,638,639,640,641,642,643,644,645,
            646,647,648,649,650,651,652,653,654,655,
            656,657,658,659,660,661,662,663,664,665,
            666,667,668,669,670,671,672,673,674,675,
            676,677,678,679,680,681,682,683,684,685,
            686,687,688,689,690,691,692,693,694,695,
            696,697,698,699,700,701,702,703,704,705,
            706,707,708,709,710,711,712,713,714,715,
            716,717,718,719,720,721,722,723,724,725,
            726,727,728,729,730,731,732,733,734,735,
            736,737,738,0,0,0,3,4,5,6,
            7,8,9,10,11,12,13,14,15,16,
            17,18,19,20,21,22,23,24,25,26,
            26,28,29,30,31,32,33,34,35,36,
            37,38,39,40,41,42,43,44,45,46,
            47,48,49,50,51,52,53,54,55,56,
            57,58,59,60,61,62,63,64,65,66,
            67,68,69,70,71,72,73,74,75,76,
            77,78,79,80,81,82,83,84,85,86,
            87,88,89,90,91,92,93,94,95,96,
            97,98,99,100,101,102,0,104,105,106,
            107,108,109,110,111,112,113,114,115,116,
            117,118,119,120,121,122,123,124,125,126,
            127,128,129,130,131,132,133,134,135,136,
            137,138,139,140,141,142,143,144,145,146,
            147,148,149,150,151,152,153,154,155,156,
            157,158,159,160,161,162,163,164,165,166,
            167,168,169,170,171,172,173,174,175,176,
            177,178,179,180,181,182,183,184,185,186,
            187,188,189,190,191,192,193,194,195,196,
            197,198,199,200,201,202,203,204,205,206,
            207,208,209,210,211,212,213,214,215,216,
            217,218,219,220,221,222,223,224,225,226,
            227,228,229,230,231,232,233,234,235,236,
            237,238,239,240,241,242,243,244,245,246,
            247,248,249,250,251,252,253,254,255,256,
            257,258,259,260,261,262,263,264,265,266,
            267,268,269,270,271,272,273,274,275,276,
            277,278,279,280,281,282,283,284,285,286,
            287,288,289,290,291,292,293,294,295,296,
            297,298,299,300,301,302,303,304,305,306,
            307,308,309,310,311,312,313,314,315,316,
            317,318,319,320,321,322,323,324,325,326,
            327,328,329,330,331,332,333,334,335,336,
            337,338,339,340,341,342,343,344,345,346,
            347,348,349,350,351,352,353,354,355,356,
            357,358,359,360,361,362,363,364,365,366,
            367,368,369,370,371,372,373,374,375,376,
            377,378,379,380,381,382,383,384,385,386,
            387,388,389,390,391,392,393,394,395,396,
            397,398,399,400,401,402,403,404,405,406,
            407,408,409,410,411,412,413,414,415,416,
            417,418,419,420,421,422,423,424,425,426,
            427,428,429,430,431,432,433,434,435,436,
            437,438,439,440,441,442,443,444,445,446,
            447,448,449,450,451,452,453,454,455,456,
            457,458,459,460,461,462,463,464,465,466,
            467,468,469,470,471,472,473,474,475,476,
            477,478,479,480,481,482,483,484,485,486,
            487,488,489,490,491,492,493,494,495,496,
            497,498,499,500,501,502,503,504,505,506,
            507,508,509,510,511,512,513,514,515,516,
            517,518,519,520,521,522,523,524,525,526,
            527,528,529,530,531,532,533,534,535,536,
            537,538,539,540,541,542,543,544,545,546,
            547,548,549,550,551,552,553,554,555,556,
            557,558,559,560,561,562,563,564,565,566,
            567,568,569,570,571,572,573,574,575,576,
            577,578,579,580,581,582,583,584,585,586,
            587,588,589,590,591,592,593,594,595,596,
            597,598,599,600,601,602,603,604,605,606,
            607,608,609,610,611,612,613,614,615,616,
            617,618,619,620,621,622,623,624,625,626,
            627,628,629,630,631,632,633,634,635,636,
            637,638,639,640,641,642,643,644,645,646,
            647,648,649,650,651,652,653,654,655,656,
            657,658,659,660,661,662,663,664,665,666,
            667,668,669,670,671,672,673,674,675,676,
            677,678,679,680,681,682,683,684,685,686,
            687,688,689,690,691,692,693,694,695,696,
            697,698,699,700,701,702,703,704,705,706,
            707,708,709,710,711,712,713,714,715,716,
            717,718,719,720,721,722,723,724,725,726,
            727,728,729,730,731,732,733,734,735,736,
            737,738,0,0,0,3,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,0,
            28,29,30,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,20,
            48,49,50,51,52,53,54,55,56,57,
            58,59,60,61,62,63,64,65,66,67,
            68,69,70,71,72,73,74,75,76,77,
            78,79,80,81,82,83,84,85,86,87,
            88,89,90,91,92,93,94,95,96,97,
            98,99,100,101,102,0,104,105,106,107,
            108,109,110,111,112,113,114,115,116,117,
            118,119,120,121,122,123,124,125,126,127,
            128,129,130,131,132,133,134,135,136,137,
            138,139,140,141,142,143,144,145,146,147,
            148,149,150,151,152,153,154,155,156,157,
            158,159,160,161,162,163,164,165,166,167,
            168,169,170,171,172,173,174,175,176,177,
            178,179,180,181,182,183,184,185,186,187,
            188,189,190,191,192,193,194,195,196,197,
            198,199,200,201,202,203,204,205,206,207,
            208,209,210,211,212,213,214,215,216,217,
            218,219,220,221,222,223,224,225,226,227,
            228,229,230,231,232,233,234,235,236,237,
            238,239,240,241,242,243,244,245,246,247,
            248,249,250,251,252,253,254,255,256,257,
            258,259,260,261,262,263,264,265,266,267,
            268,269,270,271,272,273,274,275,276,277,
            278,279,280,281,282,283,284,285,286,287,
            288,289,290,291,292,293,294,295,296,297,
            298,299,300,301,302,303,304,305,306,307,
            308,309,310,311,312,313,314,315,316,317,
            318,319,320,321,322,323,324,325,326,327,
            328,329,330,331,332,333,334,335,336,337,
            338,339,340,341,342,343,344,345,346,347,
            348,349,350,351,352,353,354,355,356,357,
            358,359,360,361,362,363,364,365,366,367,
            368,369,370,371,372,373,374,375,376,377,
            378,379,380,381,382,383,384,385,386,387,
            388,389,390,391,392,393,394,395,396,397,
            398,399,400,401,402,403,404,405,406,407,
            408,409,410,411,412,413,414,415,416,417,
            418,419,420,421,422,423,424,425,426,427,
            428,429,430,431,432,433,434,435,436,437,
            438,439,440,441,442,443,444,445,446,447,
            448,449,450,451,452,453,454,455,456,457,
            458,459,460,461,462,463,464,465,466,467,
            468,469,470,471,472,473,474,475,476,477,
            478,479,480,481,482,483,484,485,486,487,
            488,489,490,491,492,493,494,495,496,497,
            498,499,500,501,502,503,504,505,506,507,
            508,509,510,511,512,513,514,515,516,517,
            518,519,520,521,522,523,524,525,526,527,
            528,529,530,531,532,533,534,535,536,537,
            538,539,540,541,542,543,544,545,546,547,
            548,549,550,551,552,553,554,555,556,557,
            558,559,560,561,562,563,564,565,566,567,
            568,569,570,571,572,573,574,575,576,577,
            578,579,580,581,582,583,584,585,586,587,
            588,589,590,591,592,593,594,595,596,597,
            598,599,600,601,602,603,604,605,606,607,
            608,609,610,611,612,613,614,615,616,617,
            618,619,620,621,622,623,624,625,626,627,
            628,629,630,631,632,633,634,635,636,637,
            638,639,640,641,642,643,644,645,646,647,
            648,649,650,651,652,653,654,655,656,657,
            658,659,660,661,662,663,664,665,666,667,
            668,669,670,671,672,673,674,675,676,677,
            678,679,680,681,682,683,684,685,686,687,
            688,689,690,691,692,693,694,695,696,697,
            698,699,700,701,702,703,704,705,706,707,
            708,709,710,711,712,713,714,715,716,717,
            718,719,720,721,722,723,724,725,726,727,
            728,729,730,731,732,733,734,735,736,737,
            738,0,0,0,3,4,5,6,7,8,
            9,10,11,12,13,14,15,16,17,18,
            19,20,21,22,23,24,25,26,25,28,
            29,30,31,32,33,34,35,36,37,38,
            39,40,41,42,43,44,45,46,0,48,
            49,50,51,52,53,54,55,56,57,58,
            59,60,61,62,63,64,65,66,67,68,
            69,70,71,72,73,74,75,76,77,78,
            79,80,81,82,83,84,85,86,87,88,
            89,90,91,92,93,94,95,96,97,98,
            99,100,101,102,0,104,105,106,107,108,
            109,110,111,112,113,114,115,116,117,118,
            119,120,121,122,123,124,125,126,127,128,
            129,130,131,132,133,134,135,136,137,138,
            139,140,141,142,143,144,145,146,147,148,
            149,150,151,152,153,154,155,156,157,158,
            159,160,161,162,163,164,165,166,167,168,
            169,170,171,172,173,174,175,176,177,178,
            179,180,181,182,183,184,185,186,187,188,
            189,190,191,192,193,194,195,196,197,198,
            199,200,201,202,203,204,205,206,207,208,
            209,210,211,212,213,214,215,216,217,218,
            219,220,221,222,223,224,225,226,227,228,
            229,230,231,232,233,234,235,236,237,238,
            239,240,241,242,243,244,245,246,247,248,
            249,250,251,252,253,254,255,256,257,258,
            259,260,261,262,263,264,265,266,267,268,
            269,270,271,272,273,274,275,276,277,278,
            279,280,281,282,283,284,285,286,287,288,
            289,290,291,292,293,294,295,296,297,298,
            299,300,301,302,303,304,305,306,307,308,
            309,310,311,312,313,314,315,316,317,318,
            319,320,321,322,323,324,325,326,327,328,
            329,330,331,332,333,334,335,336,337,338,
            339,340,341,342,343,344,345,346,347,348,
            349,350,351,352,353,354,355,356,357,358,
            359,360,361,362,363,364,365,366,367,368,
            369,370,371,372,373,374,375,376,377,378,
            379,380,381,382,383,384,385,386,387,388,
            389,390,391,392,393,394,395,396,397,398,
            399,400,401,402,403,404,405,406,407,408,
            409,410,411,412,413,414,415,416,417,418,
            419,420,421,422,423,424,425,426,427,428,
            429,430,431,432,433,434,435,436,437,438,
            439,440,441,442,443,444,445,446,447,448,
            449,450,451,452,453,454,455,456,457,458,
            459,460,461,462,463,464,465,466,467,468,
            469,470,471,472,473,474,475,476,477,478,
            479,480,481,482,483,484,485,486,487,488,
            489,490,491,492,493,494,495,496,497,498,
            499,500,501,502,503,504,505,506,507,508,
            509,510,511,512,513,514,515,516,517,518,
            519,520,521,522,523,524,525,526,527,528,
            529,530,531,532,533,534,535,536,537,538,
            539,540,541,542,543,544,545,546,547,548,
            549,550,551,552,553,554,555,556,557,558,
            559,560,561,562,563,564,565,566,567,568,
            569,570,571,572,573,574,575,576,577,578,
            579,580,581,582,583,584,585,586,587,588,
            589,590,591,592,593,594,595,596,597,598,
            599,600,601,602,603,604,605,606,607,608,
            609,610,611,612,613,614,615,616,617,618,
            619,620,621,622,623,624,625,626,627,628,
            629,630,631,632,633,634,635,636,637,638,
            639,640,641,642,643,644,645,646,647,648,
            649,650,651,652,653,654,655,656,657,658,
            659,660,661,662,663,664,665,666,667,668,
            669,670,671,672,673,674,675,676,677,678,
            679,680,681,682,683,684,685,686,687,688,
            689,690,691,692,693,694,695,696,697,698,
            699,700,701,702,703,704,705,706,707,708,
            709,710,711,712,713,714,715,716,717,718,
            719,720,721,722,723,724,725,726,727,728,
            729,730,731,732,733,734,735,736,737,738,
            0,0,0,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,0,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,0,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,92,93,94,95,96,97,98,99,
            100,101,102,0,104,105,106,107,108,109,
            110,111,112,113,114,115,116,117,118,119,
            120,121,122,123,124,125,126,127,128,129,
            130,131,132,133,134,135,136,137,138,139,
            140,141,142,143,144,145,146,147,148,149,
            150,151,152,153,154,155,156,157,158,159,
            160,161,162,163,164,165,166,167,168,169,
            170,171,172,173,174,175,176,177,178,179,
            180,181,182,183,184,185,186,187,188,189,
            190,191,192,193,194,195,196,197,198,199,
            200,201,202,203,204,205,206,207,208,209,
            210,211,212,213,214,215,216,217,218,219,
            220,221,222,223,224,225,226,227,228,229,
            230,231,232,233,234,235,236,237,238,239,
            240,241,242,243,244,245,246,247,248,249,
            250,251,252,253,254,255,256,257,258,259,
            260,261,262,263,264,265,266,267,268,269,
            270,271,272,273,274,275,276,277,278,279,
            280,281,282,283,284,285,286,287,288,289,
            290,291,292,293,294,295,296,297,298,299,
            300,301,302,303,304,305,306,307,308,309,
            310,311,312,313,314,315,316,317,318,319,
            320,321,322,323,324,325,326,327,328,329,
            330,331,332,333,334,335,336,337,338,339,
            340,341,342,343,344,345,346,347,348,349,
            350,351,352,353,354,355,356,357,358,359,
            360,361,362,363,364,365,366,367,368,369,
            370,371,372,373,374,375,376,377,378,379,
            380,381,382,383,384,385,386,387,388,389,
            390,391,392,393,394,395,396,397,398,399,
            400,401,402,403,404,405,406,407,408,409,
            410,411,412,413,414,415,416,417,418,419,
            420,421,422,423,424,425,426,427,428,429,
            430,431,432,433,434,435,436,437,438,439,
            440,441,442,443,444,445,446,447,448,449,
            450,451,452,453,454,455,456,457,458,459,
            460,461,462,463,464,465,466,467,468,469,
            470,471,472,473,474,475,476,477,478,479,
            480,481,482,483,484,485,486,487,488,489,
            490,491,492,493,494,495,496,497,498,499,
            500,501,502,503,504,505,506,507,508,509,
            510,511,512,513,514,515,516,517,518,519,
            520,521,522,523,524,525,526,527,528,529,
            530,531,532,533,534,535,536,537,538,539,
            540,541,542,543,544,545,546,547,548,549,
            550,551,552,553,554,555,556,557,558,559,
            560,561,562,563,564,565,566,567,568,569,
            570,571,572,573,574,575,576,577,578,579,
            580,581,582,583,584,585,586,587,588,589,
            590,591,592,593,594,595,596,597,598,599,
            600,601,602,603,604,605,606,607,608,609,
            610,611,612,613,614,615,616,617,618,619,
            620,621,622,623,624,625,626,627,628,629,
            630,631,632,633,634,635,636,637,638,639,
            640,641,642,643,644,645,646,647,648,649,
            650,651,652,653,654,655,656,657,658,659,
            660,661,662,663,664,665,666,667,668,669,
            670,671,672,673,674,675,676,677,678,679,
            680,681,682,683,684,685,686,687,688,689,
            690,691,692,693,694,695,696,697,698,699,
            700,701,702,703,704,705,706,707,708,709,
            710,711,712,713,714,715,716,717,718,719,
            720,721,722,723,724,725,726,727,728,729,
            730,731,732,733,734,735,736,737,738,0,
            0,0,3,4,5,6,7,8,9,10,
            11,12,13,14,15,16,17,18,19,20,
            21,22,23,24,25,26,0,28,29,30,
            31,32,33,34,35,36,37,38,39,40,
            41,42,43,44,45,46,0,48,49,50,
            51,52,53,54,55,56,57,58,59,60,
            61,62,63,64,65,66,67,68,69,70,
            71,72,73,74,75,76,77,78,79,80,
            81,82,83,84,85,86,87,88,89,90,
            91,92,93,94,95,96,97,98,99,100,
            101,102,0,104,105,106,107,108,109,110,
            111,112,113,114,115,116,117,118,119,120,
            121,122,123,124,125,126,127,128,129,130,
            131,132,133,134,135,136,137,138,139,140,
            141,142,143,144,145,146,147,148,149,150,
            151,152,153,154,155,156,157,158,159,160,
            161,162,163,164,165,166,167,168,169,170,
            171,172,173,174,175,176,177,178,179,180,
            181,182,183,184,185,186,187,188,189,190,
            191,192,193,194,195,196,197,198,199,200,
            201,202,203,204,205,206,207,208,209,210,
            211,212,213,214,215,216,217,218,219,220,
            221,222,223,224,225,226,227,228,229,230,
            231,232,233,234,235,236,237,238,239,240,
            241,242,243,244,245,246,247,248,249,250,
            251,252,253,254,255,256,257,258,259,260,
            261,262,263,264,265,266,267,268,269,270,
            271,272,273,274,275,276,277,278,279,280,
            281,282,283,284,285,286,287,288,289,290,
            291,292,293,294,295,296,297,298,299,300,
            301,302,303,304,305,306,307,308,309,310,
            311,312,313,314,315,316,317,318,319,320,
            321,322,323,324,325,326,327,328,329,330,
            331,332,333,334,335,336,337,338,339,340,
            341,342,343,344,345,346,347,348,349,350,
            351,352,353,354,355,356,357,358,359,360,
            361,362,363,364,365,366,367,368,369,370,
            371,372,373,374,375,376,377,378,379,380,
            381,382,383,384,385,386,387,388,389,390,
            391,392,393,394,395,396,397,398,399,400,
            401,402,403,404,405,406,407,408,409,410,
            411,412,413,414,415,416,417,418,419,420,
            421,422,423,424,425,426,427,428,429,430,
            431,432,433,434,435,436,437,438,439,440,
            441,442,443,444,445,446,447,448,449,450,
            451,452,453,454,455,456,457,458,459,460,
            461,462,463,464,465,466,467,468,469,470,
            471,472,473,474,475,476,477,478,479,480,
            481,482,483,484,485,486,487,488,489,490,
            491,492,493,494,495,496,497,498,499,500,
            501,502,503,504,505,506,507,508,509,510,
            511,512,513,514,515,516,517,518,519,520,
            521,522,523,524,525,526,527,528,529,530,
            531,532,533,534,535,536,537,538,539,540,
            541,542,543,544,545,546,547,548,549,550,
            551,552,553,554,555,556,557,558,559,560,
            561,562,563,564,565,566,567,568,569,570,
            571,572,573,574,575,576,577,578,579,580,
            581,582,583,584,585,586,587,588,589,590,
            591,592,593,594,595,596,597,598,599,600,
            601,602,603,604,605,606,607,608,609,610,
            611,612,613,614,615,616,617,618,619,620,
            621,622,623,624,625,626,627,628,629,630,
            631,632,633,634,635,636,637,638,639,640,
            641,642,643,644,645,646,647,648,649,650,
            651,652,653,654,655,656,657,658,659,660,
            661,662,663,664,665,666,667,668,669,670,
            671,672,673,674,675,676,677,678,679,680,
            681,682,683,684,685,686,687,688,689,690,
            691,692,693,694,695,696,697,698,699,700,
            701,702,703,704,705,706,707,708,709,710,
            711,712,713,714,715,716,717,718,719,720,
            721,722,723,724,725,726,727,728,729,730,
            731,732,733,734,735,736,737,738,0,0,
            0,3,4,5,6,7,8,9,10,11,
            12,13,14,15,16,17,18,19,20,21,
            22,23,24,25,26,0,28,29,30,31,
            32,33,34,35,36,37,38,39,40,41,
            42
        };
    };

    public interface TermCheck1 {
        public final static char termCheck1[] = {
            43,44,45,46,0,48,49,50,51,52,
            53,54,55,56,57,58,59,60,61,62,
            63,64,65,66,67,68,69,70,71,72,
            73,74,75,76,77,78,79,80,81,82,
            83,84,85,86,87,88,89,90,91,92,
            93,94,95,96,97,98,99,100,101,102,
            0,104,105,106,107,108,109,110,111,112,
            113,114,115,116,117,118,119,120,121,122,
            123,124,125,126,127,128,129,130,131,132,
            133,134,135,136,137,138,139,140,141,142,
            143,144,145,146,147,148,149,150,151,152,
            153,154,155,156,157,158,159,160,161,162,
            163,164,165,166,167,168,169,170,171,172,
            173,174,175,176,177,178,179,180,181,182,
            183,184,185,186,187,188,189,190,191,192,
            193,194,195,196,197,198,199,200,201,202,
            203,204,205,206,207,208,209,210,211,212,
            213,214,215,216,217,218,219,220,221,222,
            223,224,225,226,227,228,229,230,231,232,
            233,234,235,236,237,238,239,240,241,242,
            243,244,245,246,247,248,249,250,251,252,
            253,254,255,256,257,258,259,260,261,262,
            263,264,265,266,267,268,269,270,271,272,
            273,274,275,276,277,278,279,280,281,282,
            283,284,285,286,287,288,289,290,291,292,
            293,294,295,296,297,298,299,300,301,302,
            303,304,305,306,307,308,309,310,311,312,
            313,314,315,316,317,318,319,320,321,322,
            323,324,325,326,327,328,329,330,331,332,
            333,334,335,336,337,338,339,340,341,342,
            343,344,345,346,347,348,349,350,351,352,
            353,354,355,356,357,358,359,360,361,362,
            363,364,365,366,367,368,369,370,371,372,
            373,374,375,376,377,378,379,380,381,382,
            383,384,385,386,387,388,389,390,391,392,
            393,394,395,396,397,398,399,400,401,402,
            403,404,405,406,407,408,409,410,411,412,
            413,414,415,416,417,418,419,420,421,422,
            423,424,425,426,427,428,429,430,431,432,
            433,434,435,436,437,438,439,440,441,442,
            443,444,445,446,447,448,449,450,451,452,
            453,454,455,456,457,458,459,460,461,462,
            463,464,465,466,467,468,469,470,471,472,
            473,474,475,476,477,478,479,480,481,482,
            483,484,485,486,487,488,489,490,491,492,
            493,494,495,496,497,498,499,500,501,502,
            503,504,505,506,507,508,509,510,511,512,
            513,514,515,516,517,518,519,520,521,522,
            523,524,525,526,527,528,529,530,531,532,
            533,534,535,536,537,538,539,540,541,542,
            543,544,545,546,547,548,549,550,551,552,
            553,554,555,556,557,558,559,560,561,562,
            563,564,565,566,567,568,569,570,571,572,
            573,574,575,576,577,578,579,580,581,582,
            583,584,585,586,587,588,589,590,591,592,
            593,594,595,596,597,598,599,600,601,602,
            603,604,605,606,607,608,609,610,611,612,
            613,614,615,616,617,618,619,620,621,622,
            623,624,625,626,627,628,629,630,631,632,
            633,634,635,636,637,638,639,640,641,642,
            643,644,645,646,647,648,649,650,651,652,
            653,654,655,656,657,658,659,660,661,662,
            663,664,665,666,667,668,669,670,671,672,
            673,674,675,676,677,678,679,680,681,682,
            683,684,685,686,687,688,689,690,691,692,
            693,694,695,696,697,698,699,700,701,702,
            703,704,705,706,707,708,709,710,711,712,
            713,714,715,716,717,718,719,720,721,722,
            723,724,725,726,727,728,729,730,731,732,
            733,734,735,736,737,738,0,0,0,0,
            3,3,3,0,6,7,8,9,10,11,
            12,13,14,14,0,0,18,0,22,4,
            0,23,0,1,2,27,4,5,0,15,
            34,33,0,35,36,15,38,0,24,17,
            43,0,20,21,0,25,0,1,2,53,
            54,37,56,57,58,59,60,61,62,63,
            0,65,47,19,0,0,52,47,0,4,
            5,75,76,27,6,0,16,9,0,83,
            66,13,7,8,0,10,22,12,4,0,
            30,95,78,29,98,99,100,19,34,15,
            0,103,742,0,72,16,42,7,8,25,
            10,47,12,38,94,0,0,53,54,30,
            56,57,58,59,60,61,62,63,0,65,
            0,47,0,0,0,1,2,3,38,75,
            76,145,146,0,1,2,150,83,33,0,
            1,2,0,19,22,0,26,25,55,95,
            5,0,98,99,100,4,34,64,104,105,
            174,175,17,0,71,179,21,4,94,47,
            47,103,79,80,81,53,54,44,56,57,
            58,59,60,61,62,63,93,65,68,50,
            0,40,0,51,31,102,0,75,76,7,
            8,0,10,0,12,83,67,0,45,0,
            1,2,22,4,5,23,94,95,0,233,
            98,99,100,237,34,0,17,103,0,20,
            21,0,0,0,0,0,27,47,6,253,
            254,9,14,53,54,13,56,57,58,59,
            60,61,62,63,47,65,0,0,55,27,
            4,43,29,29,278,75,76,64,0,1,
            2,0,47,83,71,42,42,0,22,22,
            47,47,79,80,81,95,15,0,98,99,
            100,34,91,92,26,24,93,0,1,2,
            0,0,1,2,47,102,320,0,37,304,
            53,54,0,56,57,58,59,60,61,62,
            63,0,65,52,27,339,0,1,2,28,
            0,103,75,76,22,0,0,66,103,4,
            83,34,0,0,0,0,34,47,4,78,
            15,15,95,0,24,98,99,100,0,72,
            25,25,0,377,378,53,54,25,56,57,
            58,59,60,61,62,63,55,65,304,0,
            73,0,47,47,77,64,41,75,76,47,
            0,47,71,0,15,83,70,39,0,0,
            79,80,81,0,25,47,16,95,27,47,
            98,99,100,0,93,16,3,0,15,6,
            90,23,9,102,11,0,13,0,25,94,
            94,18,29,0,7,8,94,10,48,12,
            27,0,0,1,2,42,460,0,7,8,
            47,10,27,12,27,0,0,0,11,101,
            27,6,6,6,9,9,9,0,13,13,
            13,0,0,6,41,0,9,0,6,38,
            13,9,27,27,27,13,15,97,0,0,
            15,0,0,16,27,6,25,94,9,27,
            25,0,13,15,0,1,2,15,0,1,
            2,0,0,25,528,0,27,25,47,0,
            1,2,47,0,1,2,25,0,103,0,
            39,27,3,0,0,47,28,0,47,47,
            29,29,27,0,11,0,27,0,47,0,
            27,14,3,42,42,0,1,2,47,47,
            26,0,1,2,0,94,0,1,2,94,
            27,0,0,340,340,46,0,1,2,32,
            0,0,94,0,1,2,94,601,0,1,
            2,27,101,0,49,94,0,1,2,0,
            1,2,68,31,304,41,0,1,2,0,
            0,0,1,2,0,0,0,45,103,48,
            27,74,0,1,2,0,0,82,0,0,
            15,15,0,1,2,0,103,27,652,304,
            654,27,0,0,0,0,103,0,304,0,
            0,0,0,27,29,27,27,0,0,0,
            0,0,27,0,0,16,0,42,97,27,
            18,685,686,22,0,0,0,0,3,3,
            0,0,0,103,103,27,27,0,0,0,
            47,47,47,0,47,86,103,47,32,0,
            0,0,0,0,47,0,18,47,0,27,
            47,0,0,103,0,28,27,103,103,103,
            27,47,0,0,44,0,3,0,47,103,
            27,103,103,0,0,0,0,38,103,0,
            0,27,0,755,755,103,69,0,87,761,
            761,0,47,0,761,0,0,0,47,755,
            742,27,35,756,22,761,27,103,0,0,
            0,0,39,0,0,0,0,0,0,0,
            0,69,47,756,84,28,0,756,0,739,
            88,0,0,0,47,0,0,0,47,0,
            47,0,47,47,103,27,0,0,0,0,
            0,103,0,36,0,47,47,47,47,0,
            47,47,47,47,0,103,0,0,103,89,
            51,0,0,0,15,0,0,27,0,0,
            0,27,47,0,0,0,47,0,0,0,
            0,0,0,0,27,0,0,0,27,0,
            27,0,756,0,40,27,0,87,0,0,
            44,85,27,0,756,27,27,24,85,47,
            0,0,85,47,27,0,47,0,44,0,
            27,0,5,27,0,27,27,47,47,0,
            27,0,0,0,0,0,0,27,0,0,
            0,3,0,0,0,0,0,0,0,0,
            0,27,0,0,0,0,37,0,27,0,
            27,0,27,0,43,0,27,741,0,27,
            27,0,0,0,0,0,47,0,96,47,
            103,47,0,47,0,0,0,47,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,741,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,756,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,741,0,0,0,0,756,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,756,
            0,0,0,0,0,0,0,0,741,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,741,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,741,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,741,
            0,0,741,741,0,0,0,741,0,0,
            0,0,741,0,0,0,0,741,741,741,
            741,0,0,0,742,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,741,0,0,0,
            0,741,0,0,741,0,0,0,0,0,
            0,0,0,0,0,0,741,741,0,0,
            741,0,741,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,741,0,0,0,741,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0
        };
    };

    public final static char termCheck[] = new char[TermCheck0.termCheck0.length + TermCheck1.termCheck1.length];
    {
        int index = 0;
        System.arraycopy(TermCheck0.termCheck0, 0, termCheck, index, TermCheck0.termCheck0.length);
        index += TermCheck0.termCheck0.length;
        System.arraycopy(TermCheck1.termCheck1, 0, termCheck, index, TermCheck1.termCheck1.length);
    };
    public final int termCheck(int index) { return termCheck[index]; }

    public interface TermAction0 {
        public final static char termAction0[] = {0,
            34,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,14,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,2720,2720,2720,2720,2720,2720,2720,2720,2720,
            2720,9,15,2720,2720,2720,2720,2720,43,1537,
            1233,12,857,2720,2720,2720,29,33,97,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2633,2630,
            2630,2630,2630,2716,2630,2630,2630,2630,2630,2630,
            2653,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,595,2630,2630,2630,2630,2630,2645,
            2641,2630,2709,2689,2685,2681,2705,2701,2677,2673,
            2630,2637,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2697,2693,2630,2630,2630,2630,2630,2630,2649,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2669,2630,2630,2665,2661,2657,2630,2630,91,
            2630,2627,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,3307,55,3308,330,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,23,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,1991,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,2151,
            3206,3207,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,2758,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,89,156,51,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            2791,3206,2016,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,2095,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,2788,
            3206,3206,3206,3206,3206,3206,3206,3206,167,3206,
            3207,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,2758,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,95,24,161,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2633,2630,2630,2630,
            2630,190,2630,2630,2630,2630,2630,2630,2653,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2343,2630,2630,2630,2630,2630,2645,2641,2630,
            2709,2689,2685,2681,2705,2701,2677,2673,2630,2637,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2697,
            2693,2630,2630,2630,2630,2630,2630,2649,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2669,
            2630,2630,2665,2661,2657,2630,2630,3309,2630,2627,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,3307,124,105,2018,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,2791,
            3206,2962,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,2095,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,2788,3206,
            3206,3206,3206,3206,3206,3206,3206,150,3206,3207,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,2758,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,165,202,188,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            2016,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            1991,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,200,3206,3207,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,2758,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,6,229,288,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,109,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,1042,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,312,3206,3207,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,31,3008,316,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2633,2630,2630,2630,2630,1968,2630,
            2630,2630,2630,2630,2630,2653,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,3008,2630,
            2630,2630,2630,2630,2645,2641,2630,2709,2689,2685,
            2681,2705,2701,2677,2673,2630,2637,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2697,2693,2630,2630,
            2630,2630,2630,2630,2649,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2669,2630,2630,2665,
            2661,2657,2630,2630,3008,2630,2627,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            38,3008,3008,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,3008,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,3008,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,3008,2630,2627,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,2630,
            2630,2630,2630,2630,2630,2630,2630,2630,2630,96,
            3008,3008,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,3008,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,3008,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,3008,2797,2794,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,2797,2797,
            2797,2797,2797,2797,2797,2797,2797,2797,159,3008,
            3008,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3008,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206
        };
    };

    public interface TermAction1 {
        public final static char termAction1[] = {
            3206,3206,3206,3206,3008,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            35,3206,3207,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,3206,3206,3206,3206,
            3206,3206,3206,3206,3206,3206,135,13,86,26,
            2529,2529,2529,2,2785,2785,2785,2785,2785,2785,
            2785,2785,2785,2532,10,68,2785,37,2526,2774,
            44,2785,108,1537,1233,283,1845,1037,36,879,
            2526,2785,4,2785,2785,2750,2785,60,708,2199,
            2532,61,1844,2183,5,2754,76,1537,1233,2526,
            2526,657,2526,2526,2526,2526,2526,2526,2526,2526,
            113,2526,414,2426,322,260,550,2747,18,2400,
            1576,2526,2526,2782,1276,88,2538,1297,59,2526,
            453,1377,914,3276,107,1203,3178,1180,2774,16,
            2535,2526,451,2351,2526,2526,2526,2352,1096,2750,
            132,283,3067,42,744,2538,2350,914,3276,2754,
            1203,1855,1180,272,2754,21,62,1673,1010,2535,
            3351,3359,3360,3361,3352,1171,573,3363,70,3177,
            67,2803,126,11,63,1537,1233,2529,272,1169,
            1158,2910,2874,149,1537,1233,2878,1069,1380,83,
            1537,1233,22,2621,2526,145,557,2858,2723,3364,
            1202,203,3365,3366,3367,2117,2526,2744,3206,3207,
            2902,2906,2263,147,2741,2894,2247,1170,2754,1332,
            1436,1280,2738,2735,2732,2526,2526,2279,2526,2526,
            2526,2526,2526,2526,2526,2526,2729,2526,2047,3255,
            57,2118,204,1689,3040,2726,72,2526,2526,914,
            3276,168,1203,117,1180,2526,3256,17,3039,142,
            1537,1233,2526,1845,1037,671,2854,2526,27,2862,
            2526,2526,2526,2882,2526,20,2199,244,131,1844,
            2183,73,45,243,294,19,3166,1033,1276,2926,
            2930,1297,614,2526,2526,1377,2526,2526,2526,2526,
            2526,2526,2526,2526,1495,2526,143,305,2806,845,
            2006,2373,2978,2978,2938,2526,2526,2827,69,1537,
            1233,1,688,2526,2824,2974,2974,87,3240,2526,
            1142,1855,2821,2818,2815,2526,879,7,2526,2526,
            2526,2526,3335,3336,2063,708,2812,84,1537,1233,
            104,193,1537,1233,1033,2809,2946,245,657,2778,
            2526,2526,3,2526,2526,2526,2526,2526,2526,2526,
            2526,118,2526,550,3166,2890,192,1537,1233,2311,
            50,2370,2526,2526,2526,137,130,453,842,2774,
            2526,3137,8,133,242,110,2526,457,2774,451,
            2750,2750,2526,134,1725,2526,2526,2526,177,2429,
            2754,2754,28,2918,2922,2526,2526,1653,2526,2526,
            2526,2526,2526,2526,2526,2526,2830,2526,2778,58,
            3135,52,2803,2747,3136,2851,785,2526,2526,1332,
            146,414,2848,184,879,2526,2113,2099,85,46,
            2845,2842,2839,318,2761,2101,2950,2526,3026,2624,
            2526,2526,2526,205,2836,3316,2529,213,2750,2968,
            1757,500,2968,2833,2965,79,2968,123,2754,2754,
            2754,2968,2978,141,914,3276,452,1203,2958,1180,
            279,208,53,1537,1233,2974,2934,77,914,3276,
            3005,1203,3260,1180,3383,125,153,157,2713,2100,
            3043,1276,1276,1276,1297,1297,1297,160,1377,1377,
            1377,268,189,1276,785,276,1297,47,1276,272,
            1377,1297,1988,3421,1986,1377,2750,2954,307,266,
            2750,178,309,3314,2419,1276,2994,2754,1297,3158,
            2754,240,1377,2750,232,1537,1233,2750,235,1537,
            1233,311,320,2754,2942,94,3407,2754,2986,241,
            1537,1233,2747,300,1537,1233,2858,214,758,25,
            2102,2971,2529,30,112,2747,2327,56,2104,2747,
            2978,2978,3292,127,2713,185,157,155,918,49,
            3002,614,1671,2974,2974,101,1537,1233,968,968,
            2063,129,1537,1233,187,2989,136,1537,1233,2754,
            1874,231,197,2982,2982,2621,152,1537,1233,3283,
            54,82,2754,162,1537,1233,2754,2914,186,1537,
            1233,3044,2103,255,693,2854,196,1537,1233,201,
            1537,1233,2047,3040,2778,785,237,1537,1233,80,
            256,261,1537,1233,257,274,275,3039,1015,1573,
            3105,3284,272,1537,1233,298,299,3081,308,310,
            2435,364,290,1537,1233,317,1896,3104,2870,2778,
            2866,3103,321,32,39,40,1015,41,2778,48,
            64,66,65,3375,3271,3370,3369,71,74,75,
            78,81,3194,90,92,3312,98,3272,1570,3197,
            2767,2898,2886,2770,93,99,100,102,937,2800,
            103,106,114,1920,1936,3368,3413,111,119,115,
            1521,696,476,116,712,1097,2389,1495,579,121,
            120,128,122,139,555,138,1784,1599,140,3358,
            1336,144,148,2391,151,826,3356,2392,1609,2999,
            3354,1316,154,158,2167,164,2529,166,1602,1876,
            2005,1609,1609,170,163,171,215,2361,1253,169,
            182,3189,191,283,246,1416,3046,172,3402,283,
            246,173,1795,174,2522,175,176,198,1554,3,
            3066,3215,2019,330,3239,3,3054,957,179,180,
            181,183,2026,194,195,206,207,209,199,210,
            211,3047,2030,2764,1871,826,212,1165,216,1850,
            3281,217,218,219,2031,220,221,222,2032,223,
            2033,224,2040,2098,1952,3190,225,226,227,228,
            230,2231,233,728,234,2105,2106,2107,2108,236,
            1583,1390,1822,994,238,758,239,246,2295,3099,
            898,247,244,248,879,250,249,3412,251,252,
            253,3210,2128,259,263,254,2131,269,258,262,
            270,271,273,264,3132,277,281,265,3131,283,
            3123,285,1783,267,2144,3120,278,3186,279,280,
            1124,2120,3119,282,716,3096,3209,2409,2124,2360,
            284,286,2130,2367,2433,287,2380,289,1453,291,
            3408,292,1642,3114,293,3134,3125,1346,1391,295,
            3122,301,296,302,297,303,304,3121,306,313,
            319,2529,314,315,3008,3008,3008,3008,3008,3008,
            3008,2439,3008,3008,3008,3008,1627,3008,3108,3008,
            3107,3008,3106,3008,2382,3008,3116,3401,3008,3129,
            3127,3008,3008,3008,3008,3008,1209,3008,2434,1080,
            1186,1209,3008,543,3008,3008,3008,1316,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3400,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,1167,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3296,3008,3008,3008,3008,1913,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,330,
            3008,3008,3008,3008,3008,3008,3008,3008,1343,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,1388,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,2121,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,2122,
            3008,3008,1414,2123,3008,3008,3008,2129,3008,3008,
            3008,3008,2134,3008,3008,3008,3008,2135,2136,2137,
            2138,3008,3008,3008,3264,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,2369,3008,3008,3008,
            3008,2381,3008,3008,990,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,1581,1604,3008,3008,
            1607,3008,2438,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,2443,3008,3008,3008,2450
        };
    };

    public final static char termAction[] = new char[TermAction0.termAction0.length + TermAction1.termAction1.length];
    {
        int index = 0;
        System.arraycopy(TermAction0.termAction0, 0, termAction, index, TermAction0.termAction0.length);
        index += TermAction0.termAction0.length;
        System.arraycopy(TermAction1.termAction1, 0, termAction, index, TermAction1.termAction1.length);
    };
    public final int termAction(int index) { return termAction[index]; }

    public interface DefaultReduce {
        public final static char defaultReduce[] = {0,
            410,3008,3008,3008,3008,3008,3008,3008,279,410,
            238,3008,242,3008,371,234,3008,311,409,253,
            287,3008,240,3008,242,242,3008,285,3008,279,
            3008,3008,3008,3008,3008,3008,50,3008,349,347,
            345,153,406,3008,3008,307,305,303,3008,3008,
            3008,3008,17,239,3008,291,3008,410,3008,50,
            3008,3008,242,3008,261,3008,251,3008,3008,3008,
            371,3008,3008,3008,3008,154,279,3008,3008,395,
            3008,278,249,3008,3008,242,3008,221,3008,3008,
            3008,397,3008,3008,3008,3008,3008,3008,3008,170,
            47,3008,3008,3008,3008,3008,156,3008,28,56,
            24,251,234,3008,3008,3008,152,151,261,277,
            3008,274,272,3008,3008,3008,3008,211,208,156,
            291,385,3008,289,3008,250,156,3008,3008,3008,
            3008,154,3008,3008,3008,3008,3008,3008,3008,259,
            3008,155,3008,396,3008,3008,3008,242,3008,3008,
            3008,398,3008,3008,3008,265,3008,3008,3008,3008,
            105,125,3008,122,116,3008,110,109,94,93,
            92,90,87,132,49,40,3008,156,3008,404,
            3008,257,3008,3008,3008,329,3008,25,3008,258,
            154,219,3008,272,242,3008,3008,386,267,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,71,3008,
            3008,155,3008,3008,3008,410,43,3008,3008,3008,
            155,3008,3008,107,130,3008,3008,3008,120,3008,
            3008,118,3008,3008,3008,3008,3008,3008,3008,3008,
            214,3008,3008,3008,3008,3008,3008,3008,262,3008,
            3008,185,3008,3008,183,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,213,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,185,
            3008,3008,3008,285,3008,242,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008
        };
    };
    public final static char defaultReduce[] = DefaultReduce.defaultReduce;
    public final int defaultReduce(int index) { return defaultReduce[index]; }

    public interface ShiftState {
        public final static char shiftState[] = {0,
            4571,1507,3762,4553,4696,3762,4553,4591,743,4571,
            744,761,4506,761,1,4582,2270,4644,4686,744,
            3017,4697,2270,3763,4625,3010,4698,744,764,4670,
            2270,744,2270,2,3764,3764,1,3762,744,744,
            744,4538,750,2270,4565,3009,3009,3009,758,4652,
            2270,4700,750,4686,3023,4505,3023,4669,4575,761,
            761,761,4531,2270,4702,2270,4651,2270,4654,761,
            744,4590,4590,4700,4587,4519,743,744,4587,4704,
            4706,4686,4579,4519,4703,4504,761,752,3023,744,
            4607,4686,2270,4587,764,3762,3126,4708,758,758,
            750,4707,4709,2270,4536,744,2270,4568,4712,4711,
            4716,4651,4508,4700,4700,4700,4538,4538,4702,4717,
            4721,4722,4635,3023,4565,3023,4587,4686,750,2270,
            4668,752,761,4590,3762,750,2270,744,4700,4686,
            4672,4524,4688,744,4658,2270,4552,4707,4620,2270,
            4700,750,4565,4686,4673,4724,4565,758,3762,4565,
            4607,750,4700,4686,3023,4725,3126,4567,4700,4730,
            744,744,744,744,744,744,4594,4594,744,744,
            744,4733,744,1,4674,750,4672,2270,4565,4607,
            4735,4659,4665,744,744,750,4683,4716,4700,4686,
            750,4724,2257,4603,4621,744,744,752,4734,4697,
            4706,4736,4590,4590,4590,4590,4590,4590,4736,744,
            4590,4736,744,4590,4590,4590,4590,4590,4547,4700,
            4604,4519,3764,4587,4665,4743,750,4737,4709,2270,
            750,2270,2270,744,4614,4700,4700,4700,744,4590,
            4700,744,4590,4700,4587,4587,4587,4700,4590,1504,
            750,4587,4709,4738,4700,4565,4587,2270,4686,744,
            744,750,4745,4636,4686,1517,4590,4700,4700,4700,
            4590,4700,4590,4700,4590,4590,4590,2256,753,750,
            4746,4698,4700,2270,2270,744,2270,4689,4587,4519,
            4700,4700,4700,744,3023,758,1517,4587,2270,4587,
            2270,2270,4700,4700,4700,4749,4587,1517,2270,2270,
            4587,4501
        };
    };
    public final static char shiftState[] = ShiftState.shiftState;
    public final int shiftState(int index) { return shiftState[index]; }

    public interface ShiftCheck {
        public final static char shiftCheck[] = {0,
            0,0,1,2,3,4,5,6,7,8,
            9,10,11,12,13,14,15,16,17,18,
            19,20,21,22,23,24,25,26,27,28,
            29,30,31,32,33,34,35,36,37,38,
            39,40,41,42,43,44,45,46,0,48,
            49,50,51,52,53,54,55,56,57,58,
            59,60,61,62,63,64,65,66,67,68,
            69,70,71,72,73,74,75,76,77,78,
            79,80,81,82,83,84,85,86,87,88,
            89,90,91,92,93,94,95,96,97,98,
            99,100,101,102,103,104,105,106,107,108,
            109,110,111,112,113,114,115,116,117,118,
            119,120,121,122,123,124,125,126,127,128,
            129,130,131,132,133,134,135,136,137,138,
            139,140,141,142,143,144,145,146,147,148,
            149,150,151,152,153,154,155,156,157,158,
            159,160,161,162,163,164,165,166,167,168,
            169,170,171,172,173,174,175,176,177,178,
            179,180,181,182,183,184,185,186,187,188,
            189,190,191,192,193,194,195,196,197,198,
            199,200,201,202,203,204,205,206,207,208,
            209,210,211,212,213,214,215,216,217,218,
            219,220,221,222,223,224,225,226,227,228,
            229,230,231,232,233,234,235,236,237,238,
            239,240,241,242,243,244,245,246,247,248,
            249,250,251,252,253,254,255,256,257,258,
            259,260,261,262,263,264,265,266,267,268,
            269,270,271,272,273,274,275,276,277,278,
            279,280,281,282,283,284,285,286,287,288,
            289,290,291,292,293,294,295,296,297,298,
            299,300,301,302,303,304,305,306,307,308,
            309,310,311,312,313,314,315,316,317,318,
            319,320,321,322,323,324,325,326,327,328,
            329,330,331,332,333,334,335,336,337,338,
            339,340,341,342,343,344,345,346,347,348,
            349,350,351,352,353,354,355,356,357,358,
            359,360,361,362,363,364,365,366,367,368,
            369,370,371,372,373,374,375,376,377,378,
            379,380,381,382,383,384,385,386,387,388,
            389,390,391,392,393,394,395,396,397,398,
            399,400,401,402,403,404,405,406,407,408,
            409,410,411,412,413,414,415,416,417,418,
            419,420,421,422,423,424,425,426,427,428,
            429,430,431,432,433,434,435,436,437,438,
            439,440,441,442,443,444,445,446,447,448,
            449,450,451,452,453,454,455,456,457,458,
            459,460,461,462,463,464,465,466,467,468,
            469,470,471,472,473,474,475,476,477,478,
            479,480,481,482,483,484,485,486,487,488,
            489,490,491,492,493,494,495,496,497,498,
            499,500,501,502,503,504,505,506,507,508,
            509,510,511,512,513,514,515,516,517,518,
            519,520,521,522,523,524,525,526,527,528,
            529,530,531,532,533,534,535,536,537,538,
            539,540,541,542,543,544,545,546,547,548,
            549,550,551,552,553,554,555,556,557,558,
            559,560,561,562,563,564,565,566,567,568,
            569,570,571,572,573,574,575,576,577,578,
            579,580,581,582,583,584,585,586,587,588,
            589,590,591,592,593,594,595,596,597,598,
            599,600,601,602,603,604,605,606,607,608,
            609,610,611,612,613,614,615,616,617,618,
            619,620,621,622,623,624,625,626,627,628,
            629,630,631,632,633,634,635,636,637,638,
            639,640,641,642,643,644,645,646,647,648,
            649,650,651,652,653,654,655,656,657,658,
            659,660,661,662,663,664,665,666,667,668,
            669,670,671,672,673,674,675,676,677,678,
            679,680,681,682,683,684,685,686,687,688,
            689,690,691,692,693,694,695,696,697,698,
            699,700,701,702,703,704,705,706,707,708,
            709,710,711,712,713,714,715,716,717,718,
            719,720,721,722,723,724,725,726,727,728,
            729,730,731,732,733,734,735,736,737,738,
            739,740,0,0,743,744,745,746,747,0,
            1,2,0,11,753,754,755,5,7,8,
            3,10,761,12,1,2,3,4,5,6,
            7,8,9,10,11,12,13,14,15,16,
            17,18,19,20,21,22,23,24,25,26,
            47,28,29,30,31,32,33,34,35,36,
            37,38,39,40,41,42,43,44,45,46,
            47,48,49,50,51,52,53,54,55,56,
            57,58,59,60,61,62,63,64,65,66,
            67,68,69,70,71,72,73,74,75,76,
            77,78,79,80,81,82,83,84,85,86,
            87,88,89,90,91,92,93,94,95,96,
            97,98,99,100,101,102,0,104,105,106,
            107,108,109,110,111,112,113,114,115,116,
            117,118,119,120,121,122,123,124,125,126,
            127,128,129,130,131,132,133,134,135,136,
            137,138,139,140,141,142,143,144,145,146,
            147,148,149,150,151,152,153,154,155,156,
            157,158,159,160,161,162,163,164,165,166,
            167,168,169,170,171,172,173,174,175,176,
            177,178,179,180,181,182,183,184,185,186,
            187,188,189,190,191,192,193,194,195,196,
            197,198,199,200,201,202,203,204,205,206,
            207,208,209,210,211,212,213,214,215,216,
            217,218,219,220,221,222,223,224,225,226,
            227,228,229,230,231,232,233,234,235,236,
            237,238,239,240,241,242,243,244,245,246,
            247,248,249,250,251,252,253,254,255,256,
            257,258,259,260,261,262,263,264,265,266,
            267,268,269,270,271,272,273,274,275,276,
            277,278,279,280,281,282,283,284,285,286,
            287,288,289,290,291,292,293,294,295,296,
            297,298,299,300,301,302,303,304,305,306,
            307,308,309,310,311,312,313,314,315,316,
            317,318,319,320,321,322,323,324,325,326,
            327,328,329,330,331,332,333,334,335,336,
            337,338,339,340,341,342,343,344,345,346,
            347,348,349,350,351,352,353,354,355,356,
            357,358,359,360,361,362,363,364,365,366,
            367,368,369,370,371,372,373,374,375,376,
            377,378,379,380,381,382,383,384,385,386,
            387,388,389,390,391,392,393,394,395,396,
            397,398,399,400,401,402,403,404,405,406,
            407,408,409,410,411,412,413,414,415,416,
            417,418,419,420,421,422,423,424,425,426,
            427,428,429,430,431,432,433,434,435,436,
            437,438,439,440,441,442,443,444,445,446,
            447,448,449,450,451,452,453,454,455,456,
            457,458,459,460,461,462,463,464,465,466,
            467,468,469,470,471,472,473,474,475,476,
            477,478,479,480,481,482,483,484,485,486,
            487,488,489,490,491,492,493,494,495,496,
            497,498,499,500,501,502,503,504,505,506,
            507,508,509,510,511,512,513,514,515,516,
            517,518,519,520,521,522,523,524,525,526,
            527,528,529,530,531,532,533,534,535,536,
            537,538,539,540,541,542,543,544,545,546,
            547,548,549,550,551,552,553,554,555,556,
            557,558,559,560,561,562,563,564,565,566,
            567,568,569,570,571,572,573,574,575,576,
            577,578,579,580,581,582,583,584,585,586,
            587,588,589,590,591,592,593,594,595,596,
            597,598,599,600,601,602,603,604,605,606,
            607,608,609,610,611,612,613,614,615,616,
            617,618,619,620,621,622,623,624,625,626,
            627,628,629,630,631,632,633,634,635,636,
            637,638,639,640,641,642,643,644,645,646,
            647,648,649,650,651,652,653,654,655,656,
            657,658,659,660,661,662,663,664,665,666,
            667,668,669,670,671,672,673,674,675,676,
            677,678,679,680,681,682,683,684,685,686,
            687,688,689,690,691,692,693,694,695,696,
            697,698,699,700,701,702,703,704,705,706,
            707,708,709,710,711,712,713,714,715,716,
            717,718,719,720,721,722,723,724,725,726,
            727,728,729,730,731,732,733,734,735,736,
            737,738,739,0,741,742,0,4,5,0,
            0,748,749,750,751,752,756,1,2,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,27,28,29,30,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,75,76,77,78,79,80,81,82,83,
            84,85,86,87,88,89,90,91,92,93,
            94,95,96,97,98,99,100,101,102,0,
            104,105,106,107,108,109,110,111,112,113,
            114,115,116,117,118,119,120,121,122,123,
            124,125,126,127,128,129,130,131,132,133,
            134,135,136,137,138,139,140,141,142,143,
            144,145,146,147,148,149,150,151,152,153,
            154,155,156,157,158,159,160,161,162,163,
            164,165,166,167,168,169,170,171,172,173,
            174,175,176,177,178,179,180,181,182,183,
            184,185,186,187,188,189,190,191,192,193,
            194,195,196,197,198,199,200,201,202,203,
            204,205,206,207,208,209,210,211,212,213,
            214,215,216,217,218,219,220,221,222,223,
            224,225,226,227,228,229,230,231,232,233,
            234,235,236,237,238,239,240,241,242,243,
            244,245,246,247,248,249,250,251,252,253,
            254,255,256,257,258,259,260,261,262,263,
            264,265,266,267,268,269,270,271,272,273,
            274,275,276,277,278,279,280,281,282,283,
            284,285,286,287,288,289,290,291,292,293,
            294,295,296,297,298,299,300,301,302,303,
            304,305,306,307,308,309,310,311,312,313,
            314,315,316,317,318,319,320,321,322,323,
            324,325,326,327,328,329,330,331,332,333,
            334,335,336,337,338,339,340,341,342,343,
            344,345,346,347,348,349,350,351,352,353,
            354,355,356,357,358,359,360,361,362,363,
            364,365,366,367,368,369,370,371,372,373,
            374,375,376,377,378,379,380,381,382,383,
            384,385,386,387,388,389,390,391,392,393,
            394,395,396,397,398,399,400,401,402,403,
            404,405,406,407,408,409,410,411,412,413,
            414,415,416,417,418,419,420,421,422,423,
            424,425,426,427,428,429,430,431,432,433,
            434,435,436,437,438,439,440,441,442,443,
            444,445,446,447,448,449,450,451,452,453,
            454,455,456,457,458,459,460,461,462,463,
            464,465,466,467,468,469,470,471,472,473,
            474,475,476,477,478,479,480,481,482,483,
            484,485,486,487,488,489,490,491,492,493,
            494,495,496,497,498,499,500,501,502,503,
            504,505,506,507,508,509,510,511,512,513,
            514,515,516,517,518,519,520,521,522,523,
            524,525,526,527,528,529,530,531,532,533,
            534,535,536,537,538,539,540,541,542,543,
            544,545,546,547,548,549,550,551,552,553,
            554,555,556,557,558,559,560,561,562,563,
            564,565,566,567,568,569,570,571,572,573,
            574,575,576,577,578,579,580,581,582,583,
            584,585,586,587,588,589,590,591,592,593,
            594,595,596,597,598,599,600,601,602,603,
            604,605,606,607,608,609,610,611,612,613,
            614,615,616,617,618,619,620,621,622,623,
            624,625,626,627,628,629,630,631,632,633,
            634,635,636,637,638,639,640,641,642,643,
            644,645,646,647,648,649,650,651,652,653,
            654,655,656,657,658,659,660,661,662,663,
            664,665,666,667,668,669,670,671,672,673,
            674,675,676,677,678,679,680,681,682,683,
            684,685,686,687,688,689,690,691,692,693,
            694,695,696,697,698,699,700,701,702,703,
            704,705,706,707,708,709,710,711,712,713,
            714,715,716,717,718,719,720,721,722,723,
            724,725,726,727,728,729,730,731,732,733,
            734,735,736,737,738,0,0,741,742,0,
            4,755,0,0,748,749,750,751,752,0,
            1,2,3,4,5,6,7,8,9,10,
            11,12,13,14,15,16,17,18,19,20,
            21,22,23,24,25,26,40,28,29,30,
            31,32,33,34,35,36,37,38,39,40,
            41,42,43,44,45,46,47,48,49,50,
            51,52,53,54,55,56,57,58,59,60,
            61,62,63,64,65,66,67,68,69,70,
            71,72,73,74,75,76,77,78,79,80,
            81,82,83,84,85,86,87,88,89,90,
            91,92,93,94,95,96,97,98,99,100,
            101,102,0,104,105,106,107,108,109,110,
            111,112,113,114,115,116,117,118,119,120,
            121,122,123,124,125,126,127,128,129,130,
            131,132,133,134,135,136,137,138,139,140,
            141,142,143,144,145,146,147,148,149,150,
            151,152,153,154,155,156,157,158,159,160,
            161,162,163,164,165,166,167,168,169,170,
            171,172,173,174,175,176,177,178,179,180,
            181,182,183,184,185,186,187,188,189,190,
            191,192,193,194,195,196,197,198,199,200,
            201,202,203,204,205,206,207,208,209,210,
            211,212,213,214,215,216,217,218,219,220,
            221,222,223,224,225,226,227,228,229,230,
            231,232,233,234,235,236,237,238,239,240,
            241,242,243,244,245,246,247,248,249,250,
            251,252,253,254,255,256,257,258,259,260,
            261,262,263,264,265,266,267,268,269,270,
            271,272,273,274,275,276,277,278,279,280,
            281,282,283,284,285,286,287,288,289,290,
            291,292,293,294,295,296,297,298,299,300,
            301,302,303,304,305,306,307,308,309,310,
            311,312,313,314,315,316,317,318,319,320,
            321,322,323,324,325,326,327,328,329,330,
            331,332,333,334,335,336,337,338,339,340,
            341,342,343,344,345,346,347,348,349,350,
            351,352,353,354,355,356,357,358,359,360,
            361,362,363,364,365,366,367,368,369,370,
            371,372,373,374,375,376,377,378,379,380,
            381,382,383,384,385,386,387,388,389,390,
            391,392,393,394,395,396,397,398,399,400,
            401,402,403,404,405,406,407,408,409,410,
            411,412,413,414,415,416,417,418,419,420,
            421,422,423,424,425,426,427,428,429,430,
            431,432,433,434,435,436,437,438,439,440,
            441,442,443,444,445,446,447,448,449,450,
            451,452,453,454,455,456,457,458,459,460,
            461,462,463,464,465,466,467,468,469,470,
            471,472,473,474,475,476,477,478,479,480,
            481,482,483,484,485,486,487,488,489,490,
            491,492,493,494,495,496,497,498,499,500,
            501,502,503,504,505,506,507,508,509,510,
            511,512,513,514,515,516,517,518,519,520,
            521,522,523,524,525,526,527,528,529,530,
            531,532,533,534,535,536,537,538,539,540,
            541,542,543,544,545,546,547,548,549,550,
            551,552,553,554,555,556,557,558,559,560,
            561,562,563,564,565,566,567,568,569,570,
            571,572,573,574,575,576,577,578,579,580,
            581,582,583,584,585,586,587,588,589,590,
            591,592,593,594,595,596,597,598,599,600,
            601,602,603,604,605,606,607,608,609,610,
            611,612,613,614,615,616,617,618,619,620,
            621,622,623,624,625,626,627,628,629,630,
            631,632,633,634,635,636,637,638,639,640,
            641,642,643,644,645,646,647,648,649,650,
            651,652,653,654,655,656,657,658,659,660,
            661,662,663,664,665,666,667,668,669,670,
            671,672,673,674,675,676,677,678,679,680,
            681,682,683,684,685,686,687,688,689,690,
            691,692,693,694,695,696,697,698,699,700,
            701,702,703,704,705,706,707,708,709,710,
            711,712,713,714,715,716,717,718,719,720,
            721,722,723,724,725,726,727,728,729,730,
            731,732,733,734,735,736,737,738,0,0,
            741,742,3,758,0,760,0,748,749,750,
            751,752,0,14,16,3,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,33,
            28,29,30,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,57,
            58,59,60,61,62,63,64,65,66,67,
            68,69,70,71,72,73,74,75,76,77,
            78,79,80,81,82,83,84,85,86,87,
            88,89,90,91,92,93,94,95,96,97,
            98,99,100,101,102,0,104,105,106,107,
            108,109,110,111,112,113,114,115,116,117,
            118,119,120,121,122,123,124,125,126,127,
            128,129,130,131,132,133,134,135,136,137,
            138,139,140,141,142,143,144,145,146,147,
            148,149,150,151,152,153,154,155,156,157,
            158,159,160,161,162,163,164,165,166,167,
            168,169,170,171,172,173,174,175,176,177,
            178,179,180,181,182,183,184,185,186,187,
            188,189,190,191,192,193,194,195,196,197,
            198,199,200,201,202,203,204,205,206,207,
            208,209,210,211,212,213,214,215,216,217,
            218,219,220,221,222,223,224,225,226,227,
            228,229,230,231,232,233,234,235,236,237,
            238,239,240,241,242,243,244,245,246,247,
            248,249,250,251,252,253,254,255,256,257,
            258,259,260,261,262,263,264,265,266,267,
            268,269,270,271,272,273,274,275,276,277,
            278,279,280,281,282,283,284,285,286,287,
            288,289,290,291,292,293,294,295,296,297,
            298,299,300,301,302,303,304,305,306,307,
            308,309,310,311,312,313,314,315,316,317,
            318,319,320,321,322,323,324,325,326,327,
            328,329,330,331,332,333,334,335,336,337,
            338,339,340,341,342,343,344,345,346,347,
            348,349,350,351,352,353,354,355,356,357,
            358,359,360,361,362,363,364,365,366,367,
            368,369,370,371,372,373,374,375,376,377,
            378,379,380,381,382,383,384,385,386,387,
            388,389,390,391,392,393,394,395,396,397,
            398,399,400,401,402,403,404,405,406,407,
            408,409,410,411,412,413,414,415,416,417,
            418,419,420,421,422,423,424,425,426,427,
            428,429,430,431,432,433,434,435,436,437,
            438,439,440,441,442,443,444,445,446,447,
            448,449,450,451,452,453,454,455,456,457,
            458,459,460,461,462,463,464,465,466,467,
            468,469,470,471,472,473,474,475,476,477,
            478,479,480,481,482,483,484,485,486,487,
            488,489,490,491,492,493,494,495,496,497,
            498,499,500,501,502,503,504,505,506,507,
            508,509,510,511,512,513,514,515,516,517,
            518,519,520,521,522,523,524,525,526,527,
            528,529,530,531,532,533,534,535,536,537,
            538,539,540,541,542,543,544,545,546,547,
            548,549,550,551,552,553,554,555,556,557,
            558,559,560,561,562,563,564,565,566,567,
            568,569,570,571,572,573,574,575,576,577,
            578,579,580,581,582,583,584,585,586,587,
            588,589,590,591,592,593,594,595,596,597,
            598,599,600,601,602,603,604,605,606,607,
            608,609,610,611,612,613,614,615,616,617,
            618,619,620,621,622,623,624,625,626,627,
            628,629,630,631,632,633,634,635,636,637,
            638,639,640,641,642,643,644,645,646,647,
            648,649,650,651,652,653,654,655,656,657,
            658,659,660,661,662,663,664,665,666,667,
            668,669,670,671,672,673,674,675,676,677,
            678,679,680,681,682,683,684,685,686,687,
            688,689,690,691,692,693,694,695,696,697,
            698,699,700,701,702,703,704,705,706,707,
            708,709,710,711,712,713,714,715,716,717,
            718,719,720,721,722,723,724,725,726,727,
            728,729,730,731,732,733,734,735,736,737,
            738,0,0,0,3,4,5,6,7,8,
            9,10,11,12,13,14,15,16,17,18,
            19,20,21,22,23,24,25,26,0,28,
            29,30,31,32,33,34,35,36,37,38,
            39,40,41,42,43,44,45,46,46,48,
            49,50,51,52,53,54,55,56,57,58,
            59,60,61,62,63,64,65,66,67,68,
            69,70,71,72,73,74,75,76,77,78,
            79,80,81,82,83,84,85,86,87,88,
            89,90,91,92,93,94,95,96,97,98,
            99,100,101,102,739,104,105,106,107,108,
            109,110,111,112,113,114,115,116,117,118,
            119,120,121,122,123,124,125,126,127,128,
            129,130,131,132,133,134,135,136,137,138,
            139,140,141,142,143,144,145,146,147,148,
            149,150,151,152,153,154,155,156,157,158,
            159,160,161,162,163,164,165,166,167,168,
            169,170,171,172,173,174,175,176,177,178,
            179,180,181,182,183,184,185,186,187,188,
            189,190,191,192,193,194,195,196,197,198,
            199,200,201,202,203,204,205,206,207,208,
            209,210,211,212,213,214,215,216,217,218,
            219,220,221,222,223,224,225,226,227,228,
            229,230,231,232,233,234,235,236,237,238,
            239,240,241,242,243,244,245,246,247,248,
            249,250,251,252,253,254,255,256,257,258,
            259,260,261,262,263,264,265,266,267,268,
            269,270,271,272,273,274,275,276,277,278,
            279,280,281,282,283,284,285,286,287,288,
            289,290,291,292,293,294,295,296,297,298,
            299,300,301,302,303,304,305,306,307,308,
            309,310,311,312,313,314,315,316,317,318,
            319,320,321,322,323,324,325,326,327,328,
            329,330,331,332,333,334,335,336,337,338,
            339,340,341,342,343,344,345,346,347,348,
            349,350,351,352,353,354,355,356,357,358,
            359,360,361,362,363,364,365,366,367,368,
            369,370,371,372,373,374,375,376,377,378,
            379,380,381,382,383,384,385,386,387,388,
            389,390,391,392,393,394,395,396,397,398,
            399,400,401,402,403,404,405,406,407,408,
            409,410,411,412,413,414,415,416,417,418,
            419,420,421,422,423,424,425,426,427,428,
            429,430,431,432,433,434,435,436,437,438,
            439,440,441,442,443,444,445,446,447,448,
            449,450,451,452,453,454,455,456,457,458,
            459,460,461,462,463,464,465,466,467,468,
            469,470,471,472,473,474,475,476,477,478,
            479,480,481,482,483,484,485,486,487,488,
            489,490,491,492,493,494,495,496,497,498,
            499,500,501,502,503,504,505,506,507,508,
            509,510,511,512,513,514,515,516,517,518,
            519,520,521,522,523,524,525,526,527,528,
            529,530,531,532,533,534,535,536,537,538,
            539,540,541,542,543,544,545,546,547,548,
            549,550,551,552,553,554,555,556,557,558,
            559,560,561,562,563,564,565,566,567,568,
            569,570,571,572,573,574,575,576,577,578,
            579,580,581,582,583,584,585,586,587,588,
            589,590,591,592,593,594,595,596,597,598,
            599,600,601,602,603,604,605,606,607,608,
            609,610,611,612,613,614,615,616,617,618,
            619,620,621,622,623,624,625,626,627,628,
            629,630,631,632,633,634,635,636,637,638,
            639,640,641,642,643,644,645,646,647,648,
            649,650,651,652,653,654,655,656,657,658,
            659,660,661,662,663,664,665,666,667,668,
            669,670,671,672,673,674,675,676,677,678,
            679,680,681,682,683,684,685,686,687,688,
            689,690,691,692,693,694,695,696,697,698,
            699,700,701,702,703,704,705,706,707,708,
            709,710,711,712,713,714,715,716,717,718,
            719,720,721,722,723,724,725,726,727,728,
            729,730,731,732,733,734,735,736,737,738,
            0,1,2,0,0,742,3,0,3,6,
            7,8,9,10,11,12,13,14,14,1,
            2,18,22,16,1,2,23,4,5,29,
            0,1,2,3,34,0,33,30,35,36,
            17,38,42,20,21,27,0,47,43,19,
            27,0,0,53,54,4,56,57,58,59,
            60,61,62,63,0,65,0,0,1,2,
            6,4,5,9,0,75,76,13,0,1,
            2,0,31,83,17,15,0,20,21,0,
            0,27,55,19,24,95,45,16,98,99,
            100,64,0,0,104,105,0,37,71,7,
            8,30,10,27,12,25,79,80,81,0,
            1,2,52,3,72,23,6,3,50,9,
            93,11,39,13,0,0,66,47,18,102,
            47,7,8,0,10,67,12,34,78,6,
            15,48,9,0,1,2,13,91,92,1,
            2,27,5,44,0,1,2,0,0,0,
            46,0,0,0,17,24,26,103,21,26,
            11,14,0,15,94,0,73,0,0,103,
            77,4,28,25,101,0,0,0,27,0,
            97,0,0,0,32,0,0,0,0,22,
            0,0,41,31,19,0,0,29,68,18,
            0,0,49,0,0,23,27,45,70,0,
            42,20,0,0,0,0,0,0,103,32,
            43,90,0,28,0,0,74,51,0,26,
            0,41,44,0,0,82,22,15,38,35,
            0,24,0,0,0,0,0,0,39,36,
            103,0,103,25,0,69,40,0,0,0,
            0,0,37,0,0,0,0,0,103,86,
            0,0,87,0,0,0,0,0,0,0,
            84,0,0,0,0,0,0,0,0,88,
            0,0,0,0,0,0,0,0,0,0,
            85,89,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            96,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,741,742,0,0,0,739,0,748,749,
            750,751,752,0,0,0,0,0,0,0,
            0,0,0,740,0,0,743,744,745,746,
            747,0,0,0,0,740,739,0,743,744,
            745,746,747,0,0,0,0,0,0,0,
            753,754,0,0,0,0,0,0,0,0,
            0,0,0,757,0,759,0,740,0,0,
            743,744,745,746,747,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            741,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,740,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0
        };
    };
    public final static char shiftCheck[] = ShiftCheck.shiftCheck;
    public final int shiftCheck(int index) { return shiftCheck[index]; }

    public interface DefaultShift {
        public final static char defaultShift[] = {0,
            1100,1046,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2541,2526,2526,2526,2526,3371,2526,2526,2526,
            2526,2526,2526,2561,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,1705,2526,2526,2526,
            2526,2526,2553,2549,2526,2617,2597,2593,2589,2613,
            2609,2585,2581,2526,2545,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2605,2601,2526,2526,2526,2526,
            2526,2526,2557,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2577,2526,2526,2573,2569,2565,
            2526,2526,2079,2526,2523,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,2526,2526,
            2526,2526,2526,2526,2526,2526,2526,2526,1742,3326,
            1068,3065,3327,3330,3329,3331,3328,3071,3072,3068,
            3303,3304,1463,1127,702,3288,3223,3332,3224,3333,
            2720,3008,3008,3008,3008,3008,3008,3008,3008,3008,
            3008,3008,3008,3008,3008,3008,3008,3008,3008
        };
    };
    public final static char defaultShift[] = DefaultShift.defaultShift;
    public final int defaultShift(int index) { return defaultShift[index]; }

    public interface Asb {
        public final static char asb[] = {0,
            1487,1571,3107,1,3906,3107,1,1493,3107,1569,
            1529,1537,3107,3984,3107,3107,3107,3984,1578,3107,
            3,753,1493,3860,2318,748,1570,2323,752,2331,
            3107,3105,2333,3107,3107,1492,3,1510,753,753,
            1539,753,3092,2339,2339,2341,3107,3107,3091,3091,
            3091,3092,1508,753,3864,1493,3885,3885,3885,3107,
            3940,3107,3895,753,2316,753,3898,1550,762,3107,
            3921,762,1492,3107,3905,2350,3984,3984,2354,753,
            3859,753,1501,753,1574,3984,3908,3107,1527,1527,
            1527,753,753,753,753,753,753,2316,1550,3898,
            3859,3859,1539,1550,3911,3915,1510,1505,3899,753,
            3917,3103,3984,3834,762,1539,753,3921,3107,3883,
            3107,3919,753,1550,3,762,3107,3925,3957,3940,
            3927,3938,3089,753,3954,753,3878,1539,752,3871,
            3844,3846,3845,1501,753,3107,751,2316,2316,2316,
            3092,3092,753,3859,3859,1493,3107,3107,753,1541,
            753,1553,3107,3839,2325,2325,2325,2311,762,3864,
            762,1550,753,762,1517,3960,752,3107,3855,3850,
            3984,1497,3107,3087,753,752,1539,1493,2316,1519,
            3942,3869,3945,753,753,1539,3948,753,2335,753,
            753,3089,3952,752,2316,3898,3864,1517,3956,3965,
            3103,762,3864,3107,3107,3864,3883,3959,753,2316,
            1519,762,1562,3925,1498,2316,3967,3971,3971,1539,
            3971,3971,1539,3969,3969,3971,3971,3971,3976,3971,
            3981,3972,3085,3942,752,3864,3878,753,3946,3841,
            3986,753,753,753,1539,1539,1539,1539,3842,2336,
            3845,753,2316,1550,3898,3963,3990,3834,1583,1539,
            3107,1539,753,3850,3858,2323,3915,3993,1527,1527,
            1527,1527,1527,1527,3993,1539,1527,3993,1539,1527,
            1527,1527,1527,1527,1521,2316,3995,3898,2339,753,
            1550,3841,3986,753,1492,3085,3991,3954,753,752,
            753,3898,3859,753,753,3971,3890,3890,2316,2316,
            3890,2316,3971,1527,2316,3971,1527,2316,1550,1550,
            1550,2316,1527,1539,1539,3998,3842,753,1550,3954,
            3896,2316,3864,1550,753,3859,3857,1539,1539,4001,
            4016,4013,4003,752,1527,2316,2316,2316,1527,2316,
            1527,2316,1527,1527,1527,2328,1539,3950,3842,3903,
            2333,2316,753,753,753,1539,753,745,1550,3898,
            3890,3890,3890,2316,2316,2316,1539,1494,762,3107,
            752,1550,753,1550,753,753,2316,2316,2316,1495,
            1550,752,753,753,1550,713
        };
    };
    public final static char asb[] = Asb.asb;
    public final int asb(int index) { return asb[index]; }

    public interface Asr {
        public final static char asr[] = {0,
            72,0,738,737,736,735,734,733,732,731,
            730,729,728,727,726,725,724,723,722,721,
            720,719,718,717,716,715,714,713,712,711,
            710,709,708,707,706,705,704,703,702,102,
            701,700,699,698,697,696,695,694,15,693,
            14,26,692,691,690,689,688,101,687,686,
            685,25,46,684,683,682,681,680,679,24,
            678,677,676,13,675,674,673,672,671,670,
            669,668,667,666,45,665,664,663,662,661,
            660,659,658,657,656,655,654,653,652,651,
            650,44,649,648,647,646,645,644,643,642,
            641,640,639,638,637,636,635,634,633,632,
            631,630,629,628,627,626,625,624,623,622,
            621,620,619,618,617,616,615,614,613,612,
            611,610,609,608,607,606,605,604,603,97,
            602,601,600,599,598,597,596,595,96,43,
            594,593,592,591,590,589,588,587,586,94,
            585,584,93,583,582,581,580,579,578,577,
            576,575,574,573,572,571,570,92,569,91,
            568,567,12,566,565,564,563,562,561,560,
            559,558,557,556,555,554,553,552,551,550,
            549,548,547,546,545,544,543,542,541,540,
            539,538,537,536,535,534,533,532,531,530,
            529,528,527,90,526,525,524,523,522,521,
            520,519,518,517,516,515,514,513,512,511,
            510,509,508,507,506,505,504,503,89,502,
            501,500,499,498,497,496,495,494,493,492,
            491,490,489,488,487,486,485,484,483,482,
            481,480,479,478,477,88,476,475,11,41,
            474,473,472,471,470,87,469,468,23,467,
            466,465,464,463,86,85,462,461,460,459,
            458,84,4,457,456,455,454,453,452,451,
            450,449,448,447,446,445,444,443,442,441,
            82,440,81,439,438,437,436,435,434,80,
            433,432,79,431,430,429,428,78,427,426,
            425,424,423,40,422,421,420,419,77,418,
            417,416,415,414,413,412,411,410,409,408,
            407,406,405,404,403,402,21,401,400,399,
            398,397,10,396,395,394,393,74,39,392,
            391,390,389,388,73,38,387,386,385,384,
            383,20,382,381,380,72,9,379,378,377,
            376,375,374,373,37,372,371,370,8,369,
            368,367,366,365,364,363,362,361,360,359,
            358,357,356,355,5,354,353,352,351,350,
            349,348,71,347,346,345,344,343,36,342,
            341,340,35,339,338,337,336,335,334,333,
            332,331,330,7,329,19,328,327,326,325,
            324,323,33,322,321,320,32,319,318,317,
            18,316,315,314,31,313,312,311,310,309,
            308,307,306,305,304,303,302,301,300,299,
            298,297,6,296,295,294,293,292,70,291,
            290,289,69,288,287,286,285,68,284,283,
            282,281,280,279,278,277,276,275,274,273,
            272,271,270,269,268,267,266,265,264,263,
            262,67,66,261,260,259,258,257,256,255,
            254,253,252,251,250,249,248,247,246,245,
            244,243,242,241,240,239,238,237,236,235,
            64,234,233,232,231,230,229,228,227,226,
            225,224,223,222,221,220,219,218,217,216,
            215,214,213,212,211,210,209,208,207,206,
            205,204,203,202,201,200,199,198,197,55,
            196,195,194,193,192,191,190,189,188,187,
            186,185,184,183,182,181,180,179,178,177,
            176,175,174,173,172,171,170,169,168,167,
            166,165,164,163,52,162,161,160,159,51,
            158,157,156,155,154,153,152,151,150,149,
            148,147,146,145,17,144,143,142,141,140,
            139,138,137,136,135,134,133,132,131,130,
            129,128,127,126,125,50,3,49,124,123,
            122,121,48,28,120,119,118,117,116,115,
            114,113,112,111,110,109,108,107,106,739,
            16,30,47,1,2,65,22,54,53,751,
            752,742,34,83,750,741,748,749,104,105,
            56,60,61,75,76,57,58,59,62,63,
            95,98,99,100,29,42,0,3,47,0,
            739,27,742,750,741,748,749,751,752,1,
            2,738,737,736,735,734,733,732,731,730,
            729,728,727,726,725,724,723,722,721,720,
            719,718,717,716,715,714,713,712,711,710,
            709,708,707,706,705,704,703,702,102,701,
            700,699,698,697,696,695,694,693,14,26,
            692,691,690,689,688,101,687,686,685,100,
            46,684,99,683,682,681,680,679,678,677,
            676,13,675,674,673,672,671,670,669,668,
            667,666,45,665,664,663,662,661,660,659,
            658,657,656,655,654,653,652,651,650,44,
            649,648,647,646,645,644,643,641,98,640,
            639,638,637,636,635,634,633,632,631,630,
            629,628,627,626,625,624,623,622,621,620,
            619,618,617,616,615,614,613,612,611,610,
            609,608,607,606,605,604,603,97,602,601,
            600,599,598,597,596,595,96,43,95,594,
            593,592,591,590,589,588,587,586,585,584,
            93,583,582,581,580,579,578,577,576,575,
            574,573,572,571,570,92,569,91,568,42,
            567,12,566,565,564,563,562,561,560,559,
            558,557,556,555,554,553,552,551,550,549,
            548,547,546,545,544,543,542,541,540,539,
            538,537,536,535,534,533,532,531,530,529,
            528,527,90,526,525,524,523,522,521,520,
            519,518,517,516,515,514,513,512,511,510,
            509,508,507,506,505,504,503,89,502,501,
            500,499,498,497,496,495,494,493,492,491,
            490,489,488,487,486,485,484,483,482,481,
            480,479,478,477,88,476,475,11,41,474,
            473,472,471,470,87,469,468,23,467,466,
            465,464,463,86,85,462,461,460,459,458,
            84,22,4,457,456,455,454,453,452,451,
            450,449,448,447,446,445,444,443,442,441,
            83,82,440,81,439,438,437,436,435,434,
            80,433,432,79,431,430,429,428,427,426,
            425,424,423,40,422,421,420,419,77,418,
            417,416,415,414,413,412,411,410,409,408,
            76,75,407,406,405,404,403,402,21,401,
            400,399,398,397,10,396,395,394,393,74,
            39,392,391,390,389,388,73,38,387,386,
            385,384,383,20,382,381,380,72,9,379,
            378,377,376,375,374,373,372,371,370,8,
            369,368,367,366,365,364,363,362,361,360,
            359,358,357,356,355,5,354,353,352,351,
            350,349,348,71,347,346,345,344,343,36,
            342,341,340,35,339,338,337,336,335,334,
            333,332,331,34,330,7,329,19,328,327,
            326,325,324,323,33,322,321,320,32,319,
            318,317,18,316,315,314,31,313,312,311,
            310,309,308,307,306,305,304,303,302,301,
            300,299,298,297,6,296,295,294,293,292,
            70,291,290,289,69,288,287,286,285,68,
            284,283,282,281,280,279,278,277,276,275,
            274,30,273,272,271,270,269,268,267,266,
            265,264,263,262,67,261,260,259,258,257,
            256,65,255,254,253,252,251,250,249,248,
            247,246,245,244,243,242,241,240,239,238,
            237,236,235,64,234,233,232,231,230,229,
            228,227,226,63,62,61,60,59,58,57,
            56,225,29,224,223,222,221,220,219,218,
            217,216,215,214,213,212,211,210,209,208,
            207,206,205,204,203,202,201,200,199,198,
            197,55,196,195,194,193,192,191,190,189,
            188,187,186,185,184,183,182,181,180,179,
            178,177,176,175,174,173,172,171,170,54,
            53,169,168,167,166,165,164,163,162,161,
            160,159,51,158,157,156,155,154,153,152,
            151,150,149,148,147,146,145,17,144,143,
            142,141,140,139,138,137,136,135,134,133,
            132,131,130,129,128,127,126,125,50,3,
            49,124,123,122,121,48,28,120,119,118,
            117,116,16,115,114,113,112,111,110,109,
            108,107,106,104,105,642,37,24,66,78,
            52,15,94,47,25,0,741,91,92,0,
            69,26,68,0,84,50,67,1,2,6,
            18,33,9,13,27,11,755,761,103,0,
            49,82,27,757,759,0,741,0,94,25,
            15,37,24,66,78,52,755,761,47,0,
            6,18,33,9,11,13,755,761,84,27,
            103,0,7,8,38,10,23,12,14,103,
            47,6,18,36,9,13,27,35,11,33,
            761,755,0,26,1,2,0,47,103,755,
            761,756,734,733,732,731,730,729,728,727,
            726,725,724,723,722,721,720,719,718,717,
            716,715,714,713,712,711,710,709,708,707,
            706,705,704,703,702,102,701,700,699,698,
            697,696,695,694,15,693,14,26,692,691,
            690,689,688,101,687,686,685,25,100,46,
            684,99,683,682,681,680,679,24,678,677,
            676,675,674,673,672,671,670,669,668,667,
            666,45,665,664,663,662,661,660,659,658,
            657,656,655,654,653,652,651,650,44,649,
            648,647,646,645,644,643,642,641,98,640,
            639,638,637,636,635,634,633,632,631,630,
            629,628,627,626,625,624,623,622,621,620,
            619,618,617,616,615,614,613,612,611,610,
            609,608,607,606,605,604,603,97,602,601,
            600,599,598,597,596,595,96,43,95,594,
            593,592,591,590,589,588,587,586,94,585,
            584,93,583,582,581,580,579,578,577,576,
            575,574,573,572,571,570,92,569,91,568,
            42,567,566,565,564,563,562,561,560,559,
            558,557,556,555,554,553,552,551,550,549,
            548,547,546,545,544,543,542,541,540,539,
            538,537,536,535,534,533,532,531,530,529,
            528,527,90,526,525,524,523,522,521,520,
            519,518,517,516,515,514,513,512,511,510,
            509,508,507,506,505,504,503,89,502,501,
            500,499,498,497,496,495,494,493,492,491,
            490,489,488,487,486,485,484,483,482,481,
            480,479,478,477,88,476,475,41,474,473,
            472,471,470,87,469,468,23,467,466,465,
            464,463,86,85,462,461,460,459,458,84,
            22,4,457,456,455,454,453,452,451,450,
            449,448,447,446,445,444,443,442,441,83,
            82,440,81,439,438,437,436,435,434,80,
            433,432,79,431,430,429,428,78,427,426,
            425,424,423,40,422,421,420,419,77,418,
            417,416,415,414,413,412,411,410,409,408,
            76,75,407,406,405,404,403,402,21,401,
            400,399,398,397,396,395,394,393,74,39,
            392,391,390,389,388,73,387,386,385,384,
            383,20,382,381,380,72,379,378,377,376,
            375,374,373,37,372,371,370,369,368,367,
            366,365,364,363,362,361,360,359,358,357,
            356,355,5,354,353,352,351,350,349,348,
            71,347,346,345,344,343,36,342,341,340,
            35,339,338,337,336,335,334,333,332,331,
            34,330,329,19,328,327,326,325,324,323,
            33,322,321,320,32,319,318,317,316,315,
            314,31,313,312,311,310,309,308,307,306,
            305,304,303,302,301,300,299,298,297,296,
            295,294,293,292,70,291,290,289,69,288,
            287,286,285,68,284,283,282,281,280,279,
            278,277,276,275,274,30,273,272,271,270,
            269,268,267,266,265,264,263,262,67,66,
            261,260,259,258,257,256,65,255,254,253,
            252,251,250,249,248,247,246,245,244,243,
            242,241,240,239,238,237,236,235,64,234,
            233,232,231,230,229,228,227,226,63,62,
            61,60,59,58,57,56,225,29,224,223,
            222,221,220,219,218,217,216,215,214,213,
            212,211,210,209,208,207,206,205,204,203,
            202,201,200,199,198,197,55,196,195,194,
            193,192,191,190,189,188,187,186,185,184,
            183,182,181,180,179,178,177,176,175,174,
            173,172,171,170,54,53,169,168,167,166,
            165,164,163,52,162,161,160,159,51,158,
            157,156,155,154,153,152,151,150,149,148,
            147,146,145,17,144,143,142,141,140,139,
            138,137,136,135,134,133,132,131,130,129,
            128,127,126,125,50,49,124,123,122,121,
            48,28,120,119,118,117,116,16,115,114,
            113,112,111,110,109,108,107,106,735,736,
            737,738,104,105,6,18,9,13,3,11,
            38,8,10,12,7,27,0,94,25,47,
            103,0,51,0,38,88,0,758,760,0,
            46,0,43,0,4,45,31,0,742,0,
            27,743,740,744,745,746,747,755,761,739,
            753,754,756,737,736,735,734,733,732,731,
            730,729,728,727,726,725,724,723,722,721,
            720,719,718,717,716,715,714,713,712,711,
            710,709,708,707,706,705,704,703,702,102,
            701,700,699,698,697,696,695,694,15,693,
            14,692,691,690,689,688,101,687,686,685,
            25,100,46,684,99,683,682,681,680,679,
            24,678,677,676,13,675,674,673,672,671,
            670,669,668,667,666,45,665,664,663,662,
            661,660,659,658,657,656,655,654,653,652,
            651,650,44,649,648,647,646,645,644,643,
            642,641,98,640,639,638,637,636,635,634,
            633,632,631,630,629,628,627,626,625,624,
            623,622,621,620,619,618,617,616,615,614,
            613,612,611,610,609,608,607,606,605,604,
            603,97,602,601,600,599,598,597,596,595,
            96,43,95,594,593,592,591,590,589,588,
            587,586,94,585,584,93,583,582,581,580,
            579,578,577,576,575,574,573,572,571,570,
            92,569,91,568,42,567,12,566,565,564,
            563,562,561,560,559,558,557,556,555,554,
            553,552,551,550,549,548,547,546,545,544,
            543,542,541,540,539,538,537,536,535,534,
            533,532,531,530,529,528,527,90,526,525,
            524,523,522,521,520,519,518,517,516,515,
            514,513,512,511,510,509,508,507,506,505,
            504,503,89,502,501,500,499,498,497,496,
            495,494,493,492,491,490,489,488,487,486,
            485,484,483,482,481,480,479,478,477,88,
            476,475,11,41,474,473,472,471,470,87,
            469,468,23,467,466,465,464,463,86,85,
            462,461,460,459,458,84,22,4,457,456,
            455,454,453,452,451,450,449,448,447,446,
            445,444,443,442,441,83,82,440,81,439,
            438,437,436,435,434,80,433,432,79,431,
            430,429,428,78,427,426,425,424,423,40,
            422,421,420,419,77,418,417,416,415,414,
            413,412,411,410,409,408,76,75,407,406,
            405,404,403,402,21,401,400,399,398,397,
            10,396,395,394,393,74,39,392,391,390,
            389,388,73,38,387,386,385,384,383,20,
            382,381,380,72,9,379,378,377,376,375,
            374,373,37,372,371,370,8,369,368,367,
            366,365,364,363,362,361,360,359,358,357,
            356,355,5,354,353,352,351,350,349,348,
            71,347,346,345,344,343,36,342,341,340,
            35,339,338,337,336,335,334,333,332,331,
            34,330,7,329,328,327,326,325,324,323,
            33,322,321,320,32,319,318,317,18,316,
            315,314,31,313,312,311,310,309,308,307,
            306,305,304,303,302,301,300,299,298,297,
            6,296,295,294,293,292,70,291,290,289,
            288,287,286,285,284,283,282,281,280,279,
            278,277,276,275,274,30,273,272,271,270,
            269,268,267,266,265,264,263,262,67,66,
            261,260,259,258,257,256,65,255,254,253,
            252,251,250,249,248,247,246,245,244,243,
            242,241,240,239,238,237,236,235,64,234,
            233,232,231,230,229,228,227,226,63,62,
            61,60,59,58,57,56,225,29,224,223,
            222,221,220,219,218,217,216,215,214,213,
            212,211,210,209,208,207,206,205,204,203,
            202,201,200,199,198,197,55,196,195,194,
            193,192,191,190,189,188,187,186,185,184,
            183,182,181,180,179,178,177,176,175,174,
            173,172,171,170,54,53,169,168,167,166,
            165,164,163,52,162,161,160,159,51,158,
            157,156,155,154,153,152,151,150,149,148,
            147,146,145,17,144,143,142,141,140,139,
            138,137,136,135,134,133,132,131,130,129,
            128,127,126,125,50,49,124,123,122,121,
            48,28,120,119,118,117,116,16,115,114,
            113,112,111,110,109,108,107,106,738,103,
            104,105,19,3,68,26,1,2,69,0,
            47,739,1,2,753,743,740,744,745,746,
            747,754,27,103,755,761,738,737,736,735,
            734,733,732,731,730,729,728,727,726,725,
            724,723,722,721,720,719,718,717,716,715,
            714,713,712,711,710,709,708,707,706,705,
            704,703,702,102,701,700,699,698,697,696,
            695,694,15,693,14,26,692,691,690,689,
            688,101,687,686,685,25,100,46,684,99,
            683,682,681,680,679,24,678,677,676,13,
            675,674,673,672,671,670,669,668,667,666,
            45,665,664,663,662,661,660,659,658,657,
            656,655,654,653,652,651,650,44,649,648,
            647,646,645,644,643,642,641,98,640,639,
            638,637,636,635,634,633,632,631,630,629,
            628,627,626,625,624,623,622,621,620,619,
            618,617,616,615,614,613,612,611,610,609,
            608,607,606,605,604,603,97,602,601,600,
            599,598,597,596,595,96,43,95,594,593,
            592,591,590,589,588,587,586,94,585,584,
            93,583,582,581,580,579,578,577,576,575,
            574,573,572,571,570,92,569,91,568,42,
            567,566,565,564,563,562,561,560,559,558,
            557,556,555,554,553,552,551,550,549,548,
            547,546,545,544,543,542,541,540,539,538,
            537,536,535,534,533,532,531,530,529,528,
            527,90,526,525,524,523,522,521,520,519,
            518,517,516,515,514,513,512,511,510,509,
            508,507,506,505,504,503,89,502,501,500,
            499,498,497,496,495,494,493,492,491,490,
            489,488,487,486,485,484,483,482,481,480,
            479,478,477,88,476,475,11,41,474,473,
            472,471,470,87,469,468,467,466,465,464,
            463,86,85,462,461,460,459,458,84,22,
            4,457,456,455,454,453,452,451,450,449,
            448,447,446,445,444,443,442,441,83,82,
            440,81,439,438,437,436,435,434,80,433,
            432,79,431,430,429,428,78,427,426,425,
            424,423,40,422,421,420,419,77,418,417,
            416,415,414,413,412,411,410,409,408,76,
            75,407,406,405,404,403,402,21,401,400,
            399,398,397,396,395,394,393,74,39,392,
            391,390,389,388,73,387,386,385,384,383,
            20,382,381,380,72,9,379,378,377,376,
            375,374,373,37,372,371,370,369,368,367,
            366,365,364,363,362,361,360,359,358,357,
            356,355,5,354,353,352,351,350,349,348,
            71,347,346,345,344,343,36,342,341,340,
            35,339,338,337,336,335,334,333,332,331,
            34,330,329,19,328,327,326,325,324,323,
            33,322,321,320,32,319,318,317,18,316,
            315,314,31,313,312,311,310,309,308,307,
            306,305,304,303,302,301,300,299,298,297,
            6,296,295,294,293,292,70,291,290,289,
            69,288,287,286,285,68,284,283,282,281,
            280,279,278,277,276,275,274,30,273,272,
            271,270,269,268,267,266,265,264,263,262,
            67,66,261,260,259,258,257,256,65,255,
            254,253,252,251,250,249,248,247,246,245,
            244,243,242,241,240,239,238,237,236,235,
            64,234,233,232,231,230,229,228,227,226,
            63,62,61,60,59,58,57,56,225,29,
            224,223,222,221,220,219,218,217,216,215,
            214,213,212,211,210,209,208,207,206,205,
            204,203,202,201,200,199,198,197,55,196,
            195,194,193,192,191,190,189,188,187,186,
            185,184,183,182,181,180,179,178,177,176,
            175,174,173,172,171,170,54,53,169,168,
            167,166,165,164,163,52,162,161,160,159,
            51,158,157,156,155,154,153,152,151,150,
            149,148,147,146,145,17,144,143,142,141,
            140,139,138,137,136,135,134,133,132,131,
            130,129,128,127,126,125,50,3,49,124,
            123,122,121,48,28,120,119,118,117,116,
            16,115,114,113,112,111,110,109,108,107,
            106,104,105,23,8,10,12,7,38,0,
            70,1,2,20,28,23,44,26,41,38,
            8,10,12,7,35,14,103,36,18,33,
            11,755,761,13,9,6,27,0,103,27,
            1,2,4,5,17,21,20,743,747,745,
            744,746,740,0,94,25,47,16,0,27,
            73,77,34,0,90,24,0,103,1,2,
            27,0,37,0,103,19,0,756,47,0,
            755,761,86,0,87,0,23,0,26,103,
            755,761,14,0,739,0,55,64,71,79,
            80,81,93,102,739,753,754,1,2,3,
            0,41,27,0,4,22,0,17,21,5,
            0,1,2,44,0,74,32,0,14,103,
            1,2,755,761,26,0,39,0,101,39,
            47,27,49,82,0,49,82,27,89,0,
            49,82,27,756,0,1,2,28,0,4,
            40,0,85,0,48,97,0,4,5,0,
            1,2,6,18,33,36,9,11,13,27,
            755,761,15,103,0,96,0
        };
    };
    public final static char asr[] = Asr.asr;
    public final int asr(int index) { return asr[index]; }

    public interface Nasb {
        public final static char nasb[] = {0,
            53,8,34,8,8,7,8,108,97,27,
            53,21,7,8,7,7,31,8,8,7,
            15,6,108,56,8,25,13,8,6,8,
            60,31,8,90,90,58,6,27,6,6,
            8,134,8,8,8,8,7,43,8,8,
            8,17,8,4,56,23,8,8,8,89,
            8,73,8,6,8,4,8,8,7,29,
            51,148,53,6,8,8,8,8,60,6,
            11,6,63,38,85,8,8,7,77,19,
            77,6,6,6,6,6,6,8,8,8,
            27,27,8,8,8,8,8,68,8,6,
            8,143,8,66,107,8,38,51,6,8,
            90,8,6,8,6,7,90,8,8,8,
            8,8,8,6,8,92,49,8,1,49,
            8,8,8,70,6,79,15,8,8,8,
            17,17,6,11,11,108,83,73,6,81,
            38,25,90,8,102,102,102,66,107,56,
            126,8,6,110,8,8,3,6,51,66,
            8,47,6,8,6,1,95,108,8,8,
            8,49,8,6,6,116,8,6,118,38,
            38,8,8,6,8,8,56,8,8,146,
            143,7,56,143,7,56,8,8,6,8,
            8,7,120,8,87,8,8,8,8,8,
            8,8,8,8,8,8,8,8,8,8,
            8,8,8,8,138,56,8,6,8,124,
            8,4,6,6,116,116,116,116,8,118,
            8,6,8,8,8,9,8,66,142,8,
            143,8,6,66,100,8,8,8,8,8,
            8,8,8,8,8,8,8,8,8,8,
            8,8,8,8,75,8,8,8,8,6,
            8,124,8,4,53,8,8,8,38,6,
            106,8,27,38,6,8,130,130,8,8,
            130,8,8,8,8,8,8,8,8,8,
            8,8,8,116,116,8,8,6,8,8,
            122,8,56,8,104,11,8,8,8,8,
            8,8,8,4,8,8,8,8,8,8,
            8,8,8,8,8,114,116,8,8,132,
            8,8,6,6,6,8,6,8,8,8,
            130,130,130,8,8,8,116,58,148,143,
            4,8,4,8,6,6,8,8,8,8,
            8,4,6,6,8,6
        };
    };
    public final static char nasb[] = Nasb.nasb;
    public final int nasb(int index) { return nasb[index]; }

    public interface Nasr {
        public final static char nasr[] = {0,
            20,36,59,18,17,3,1,0,97,0,
            62,0,158,0,89,0,67,0,163,0,
            119,0,30,0,101,0,48,0,114,0,
            22,87,0,2,3,118,0,36,20,3,
            1,0,2,3,86,0,143,0,64,0,
            66,0,17,18,0,41,0,94,0,22,
            96,0,82,83,0,57,0,153,0,82,
            84,0,85,0,131,0,105,0,5,0,
            156,0,65,0,121,0,144,0,109,16,
            0,3,1,23,20,0,16,164,0,155,
            0,70,0,18,17,3,1,37,0,3,
            1,71,0,132,0,4,0,81,0,154,
            0,151,0,95,0,37,2,3,0,44,
            0,152,0,3,1,120,0,3,1,59,
            0,48,39,22,0,150,0,107,3,1,
            0
        };
    };
    public final static char nasr[] = Nasr.nasr;
    public final int nasr(int index) { return nasr[index]; }

    public interface TerminalIndex {
        public final static char terminalIndex[] = {0,
            8,10,52,443,318,249,288,334,346,370,
            468,564,686,711,713,39,74,271,286,351,
            376,444,458,690,700,710,4,45,160,222,
            267,275,279,290,300,304,338,357,364,401,
            467,566,599,658,675,698,3,46,51,53,
            89,94,102,103,131,162,163,164,165,166,
            167,168,169,179,201,208,209,234,239,243,
            310,347,358,365,383,384,396,407,412,415,
            422,424,425,445,451,452,461,471,498,523,
            568,570,585,588,598,600,609,648,696,699,
            704,722,9,761,762,29,30,31,32,33,
            34,35,36,37,38,40,41,42,43,44,
            47,48,49,50,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,75,76,77,78,79,80,
            81,82,83,84,85,86,87,88,90,91,
            92,93,95,96,97,98,99,100,101,104,
            105,106,107,108,109,110,111,112,113,114,
            115,116,117,118,119,120,121,122,123,124,
            125,126,127,128,129,130,132,133,134,135,
            136,137,138,139,140,141,142,143,144,145,
            146,147,148,149,150,151,152,153,154,155,
            156,157,158,159,161,170,171,172,173,174,
            175,176,177,178,180,181,182,183,184,185,
            186,187,188,189,190,191,192,193,194,195,
            196,197,198,199,200,202,203,204,205,206,
            207,210,211,212,213,214,215,216,217,218,
            219,220,221,223,224,225,226,227,228,229,
            230,231,232,233,235,236,237,238,240,241,
            242,244,245,246,247,248,250,251,252,253,
            254,255,256,257,258,259,260,261,262,263,
            264,265,266,268,269,270,272,273,274,276,
            277,278,280,281,282,283,284,285,287,289,
            291,292,293,294,295,296,297,298,299,301,
            302,303,305,306,307,308,309,311,312,313,
            314,315,316,317,319,320,321,322,323,324,
            325,326,327,328,329,330,331,332,333,335,
            336,337,339,340,341,342,343,344,345,348,
            349,350,352,353,354,355,356,359,360,361,
            362,363,366,367,368,369,371,372,373,374,
            375,377,378,379,380,381,382,385,386,387,
            388,389,390,391,392,393,394,395,397,398,
            399,400,402,403,404,405,406,408,409,410,
            411,413,414,416,417,418,419,420,421,423,
            426,427,428,429,430,431,432,433,434,435,
            436,437,438,439,440,441,442,446,447,448,
            449,450,453,454,455,456,457,459,460,462,
            463,464,465,466,469,470,472,473,474,475,
            476,477,478,479,480,481,482,483,484,485,
            486,487,488,489,490,491,492,493,494,495,
            496,497,499,500,501,502,503,504,505,506,
            507,508,509,510,511,512,513,514,515,516,
            517,518,519,520,521,522,524,525,526,527,
            528,529,530,531,532,533,534,535,536,537,
            538,539,540,541,542,543,544,545,546,547,
            548,549,550,551,552,553,554,555,556,557,
            558,559,560,561,562,563,565,567,569,571,
            572,573,574,575,576,577,578,579,580,581,
            582,583,584,586,587,589,590,591,592,593,
            594,595,596,597,601,602,603,604,605,606,
            607,608,610,611,612,613,614,615,616,617,
            618,619,620,621,622,623,624,625,626,627,
            628,629,630,631,632,633,634,635,636,637,
            638,639,640,641,642,643,644,645,646,647,
            649,650,651,652,653,654,655,656,657,659,
            660,661,662,663,664,665,666,667,668,669,
            670,671,672,673,674,676,677,678,679,680,
            681,682,683,684,685,687,688,689,691,692,
            693,694,695,697,701,702,703,705,706,707,
            708,709,712,714,715,716,717,718,719,720,
            721,723,724,725,726,727,728,729,730,731,
            732,733,734,735,736,737,738,739,740,741,
            742,743,744,745,746,747,748,749,750,751,
            752,753,754,755,756,757,758,759,7,16,
            764,772,15,17,21,22,23,766,767,771,
            777,778,12,24,776,11,19,20,779,780,
            1,5,6,13,14,18,760,25,26,763,
            765,768,769,770,773,774,775,781,2
        };
    };
    public final static char terminalIndex[] = TerminalIndex.terminalIndex;
    public final int terminalIndex(int index) { return terminalIndex[index]; }

    public interface NonterminalIndex {
        public final static char nonterminalIndex[] = {0,
            790,844,0,792,811,814,0,0,0,824,
            0,0,0,822,786,815,835,0,826,852,
            0,0,801,0,823,0,0,0,0,849,
            0,0,0,0,798,799,821,0,795,797,
            848,796,855,0,0,0,837,0,845,0,
            0,0,0,0,0,806,0,785,0,0,
            830,0,857,791,812,0,820,833,842,0,
            859,788,0,0,0,0,0,0,0,793,
            800,0,805,807,813,816,0,819,0,0,
            0,828,831,0,0,0,838,0,0,841,
            0,0,846,847,853,856,858,860,862,782,
            783,784,787,789,0,0,794,802,0,803,
            804,808,809,0,810,0,0,0,0,0,
            817,818,0,0,0,0,0,0,0,0,
            0,0,0,825,827,829,832,0,834,836,
            839,840,0,0,0,0,843,0,0,850,
            27,851,854,861,0,0,0,0,0,0,
            0,0
        };
    };
    public final static char nonterminalIndex[] = NonterminalIndex.nonterminalIndex;
    public final int nonterminalIndex(int index) { return nonterminalIndex[index]; }

    public interface ScopePrefix {
        public final static char scopePrefix[] = {
            36,1,184,204,174,199,239,28,129,140,
            140,50,54,218,253,257,15,91,91,117,
            222,75,9,12,25,47,58,196,210,261,
            22,230,236,22,246,12,12,9,9,87,
            61,66,61,61,213,61,61,61,61,61,
            61,61,61,61,61,61
        };
    };
    public final static char scopePrefix[] = ScopePrefix.scopePrefix;
    public final int scopePrefix(int index) { return scopePrefix[index]; }

    public interface ScopeSuffix {
        public final static char scopeSuffix[] = {
            43,7,7,7,7,7,244,33,121,145,
            155,7,7,7,244,7,19,95,98,121,
            226,79,7,7,7,7,7,7,7,7,
            19,233,233,71,249,264,269,149,160,89,
            63,68,101,167,215,104,108,170,274,278,
            282,112,124,179,134,190
        };
    };
    public final static char scopeSuffix[] = ScopeSuffix.scopeSuffix;
    public final int scopeSuffix(int index) { return scopeSuffix[index]; }

    public interface ScopeLhs {
        public final static char scopeLhs[] = {
            50,109,26,13,26,91,7,51,27,26,
            26,46,46,24,7,36,54,154,154,27,
            8,31,108,20,52,63,4,92,10,36,
            54,84,83,30,7,21,21,26,26,17,
            34,33,29,26,59,29,28,26,21,21,
            21,28,27,26,27,26
        };
    };
    public final static char scopeLhs[] = ScopeLhs.scopeLhs;
    public final int scopeLhs(int index) { return scopeLhs[index]; }

    public interface ScopeLa {
        public final static char scopeLa[] = {
            27,27,27,27,27,27,69,23,28,27,
            27,27,27,27,69,27,27,15,15,28,
            3,19,27,27,27,27,27,27,27,27,
            27,44,44,27,26,27,27,103,103,94,
            740,740,20,5,103,20,21,4,740,740,
            740,4,17,5,4,4
        };
    };
    public final static char scopeLa[] = ScopeLa.scopeLa;
    public final int scopeLa(int index) { return scopeLa[index]; }

    public interface ScopeStateSet {
        public final static char scopeStateSet[] = {
            38,130,116,57,116,13,57,38,116,116,
            116,9,9,116,57,117,38,16,16,116,
            57,133,127,26,38,4,48,1,57,117,
            38,23,45,133,57,116,116,116,116,144,
            116,116,116,116,18,116,116,116,116,116,
            116,116,116,116,116,116
        };
    };
    public final static char scopeStateSet[] = ScopeStateSet.scopeStateSet;
    public final int scopeStateSet(int index) { return scopeStateSet[index]; }

    public interface ScopeRhs {
        public final static char scopeRhs[] = {0,
            816,47,3,880,795,0,4,0,804,47,
            0,838,47,0,816,47,642,0,4,845,
            0,816,47,0,826,47,0,826,38,836,
            826,0,458,806,0,869,47,780,782,47,
            642,0,4,4,845,0,885,47,0,848,
            47,42,0,848,47,29,0,796,47,0,
            794,0,791,786,0,799,0,791,852,0,
            4,0,0,0,939,868,94,0,286,27,
            0,0,0,0,0,0,797,0,821,0,
            848,51,35,0,713,566,0,713,160,0,
            351,444,0,351,443,444,0,376,786,0,
            0,443,376,786,0,0,794,17,794,0,
            45,786,0,74,786,45,786,0,794,17,
            4,794,0,443,74,786,45,786,0,794,
            103,804,47,0,4,318,792,0,9,786,
            4,318,792,0,4,443,318,792,0,9,
            786,4,443,318,792,0,318,792,0,443,
            318,792,0,804,47,5,794,0,318,3,
            823,4,0,804,47,5,4,794,0,443,
            318,3,823,4,0,925,47,0,924,47,
            96,340,0,869,868,47,780,782,0,794,
            47,0,804,0,9,786,0,816,47,304,
            0,901,47,54,0,52,809,4,0,794,
            26,0,658,786,0,835,26,0,861,900,
            794,53,0,239,0,794,53,0,804,0,
            239,0,861,899,53,0,821,47,4,0,
            821,47,0,4,16,609,792,0,4,16,
            46,792,0,791,39,792,0,791,609,792,
            0,791,46,792,0
        };
    };
    public final static char scopeRhs[] = ScopeRhs.scopeRhs;
    public final int scopeRhs(int index) { return scopeRhs[index]; }

    public interface ScopeState {
        public final static char scopeState[] = {0,
            1253,1080,0,1609,1391,1346,898,0,1416,1253,
            968,1080,1186,898,0,1120,0,1795,457,1316,
            414,0,687,767,0,728,671,826,785,934,
            457,500,414,863,614,557,0,2370,2361,2095,
            2352,1991,2343,0,632,1673,0,1642,1576,1573,
            1570,1452,1378,1372,1202,1037,1416,1253,1968,968,
            1876,1080,1209,1855,1609,1391,1346,1186,1142,918,
            2327,898,994,1822,1583,2311,2295,2279,2263,2247,
            1554,2231,1795,1952,1762,2215,2199,2183,2167,1316,
            2151,1936,2079,2063,2047,1280,1726,1920,1537,1233,
            1742,1463,1300,1127,1521,1896,1705,1689,1495,1673,
            1100,1046,1478,1436,1653,863,728,671,826,785,
            457,500,414,614,557,0,1896,1653,0,842,
            879,0,918,994,1602,1336,2095,1599,1991,487,
            1332,915,0,968,1209,1855,1142,918,1390,1583,
            1554,457,1316,414,765,1705,1495,702,588,0
        };
    };
    public final static char scopeState[] = ScopeState.scopeState;
    public final int scopeState(int index) { return scopeState[index]; }

    public interface InSymb {
        public final static char inSymb[] = {0,
            0,892,52,78,66,24,37,797,15,796,
            755,897,782,781,72,19,837,781,780,72,
            94,25,47,816,943,795,827,11,47,891,
            837,837,866,801,756,837,868,941,2,1,
            54,53,741,83,34,780,782,62,76,75,
            61,793,794,47,816,820,6,9,13,103,
            880,47,33,51,895,47,794,896,46,801,
            866,43,873,47,939,780,781,795,794,103,
            827,47,899,26,794,795,780,782,47,47,
            47,754,55,753,739,2,1,796,804,794,
            27,809,3,864,24,90,936,794,794,103,
            890,795,781,826,47,642,14,879,47,785,
            782,886,25,867,103,19,756,756,18,901,
            22,794,861,68,835,4,799,304,47,794,
            815,821,819,900,26,756,47,884,942,884,
            793,793,103,827,827,47,103,86,103,932,
            23,818,756,836,7,12,10,826,47,816,
            47,867,740,103,928,794,47,103,940,826,
            795,32,3,794,44,47,843,47,838,804,
            821,794,20,21,17,5,4,843,20,41,
            28,861,794,868,739,794,816,864,84,889,
            795,38,816,27,782,816,27,794,103,838,
            804,103,845,756,922,902,146,150,237,686,
            339,179,685,174,175,253,254,460,278,320,
            780,904,794,821,47,816,27,103,4,794,
            794,47,21,17,5,16,97,48,794,4,
            819,44,869,804,794,929,26,826,27,780,
            27,740,103,826,933,35,923,39,47,47,
            47,47,47,47,39,101,47,39,101,47,
            47,47,47,47,49,838,740,794,70,28,
            804,794,794,47,47,794,4,40,23,47,
            47,794,934,36,51,85,741,741,741,741,
            741,741,85,47,741,85,47,741,741,741,
            741,741,910,97,48,27,794,28,804,40,
            44,869,816,804,47,827,926,42,29,794,
            340,848,798,47,47,823,823,823,47,741,
            47,741,103,103,103,741,5,4,794,44,
            24,27,103,47,47,96,103,15,885,794,
            741,741,741,741,741,741,5,37,43,27,
            47,848,47,848,47,103,823,823,823,873,
            924,47,25,103,925,103
        };
    };
    public final static char inSymb[] = InSymb.inSymb;
    public final int inSymb(int index) { return inSymb[index]; }

    public interface Name {
        public final static String name[] = {
            "",
            "END-OF-COMMANDS",
            "Valid token",
            "(",
            ")",
            "\"",
            "'",
            "*",
            "+",
            ",",
            "-",
            ".",
            "/",
            ":",
            ";",
            "<",
            "=",
            ">",
            "?",
            "[",
            "]",
            "<>",
            ">=",
            "<=",
            "||",
            "..",
            "->",
            "table1, table2, table3, ...",
            "$empty",
            "ACCESS",
            "ACCTNG",
            "ACTION",
            "ACTIVATE",
            "ADD",
            "ADMIN",
            "ADMINISTRATION",
            "AFTER",
            "AGE",
            "ALIAS",
            "ALL",
            "ALLOCATE",
            "ALLOW",
            "ALTER",
            "ALTERIN",
            "ALWAYS",
            "AND",
            "ANY",
            "APPEND",
            "APPL_ID",
            "APPL_NAME",
            "APPLNAME",
            "ARRAY",
            "AS",
            "ASC",
            "ASCII",
            "ASENSITIVE",
            "ASSIGNMENT",
            "ASSOCIATE",
            "AST",
            "ASUTIME",
            "AT",
            "ATOMIC",
            "ATTRIBUTE",
            "ATTRIBUTES",
            "AUTHORIZATION",
            "AUTH_ID",
            "AUTHID",
            "AUTOMATIC",
            "AUTOSTART",
            "AVAILABLE",
            "B",
            "BEFORE",
            "BEGIN",
            "BERNOULLI",
            "BETWEEN",
            "BIGINT",
            "BINARY",
            "BIND",
            "BINDADD",
            "BIT",
            "BLOB",
            "BLOCKED",
            "BLOCKSIZE",
            "BOTH",
            "BUFFER",
            "BUFFERPOOL",
            "BUFFERPOOLS",
            "BUFFERSIZE",
            "BUILD",
            "BY",
            "BYPASS",
            "C",
            "CACHE",
            "CACHING",
            "CALL",
            "CALLED",
            "CALLER",
            "CAPTURE",
            "CARDINALITIES",
            "CARDINALITY",
            "CASCADE",
            "CASCADED",
            "CASE",
            "CAST",
            "CCSID",
            "CHANGE",
            "CHANGED",
            "CHANGES",
            "CHAR",
            "CHARACTER",
            "CHECK",
            "CHECKED",
            "CLIENT",
            "CLOB",
            "CLOSE",
            "CLR",
            "CLUSTER",
            "COBOL",
            "COLLECT",
            "COLLID",
            "COLUMN",
            "COLUMNS",
            "COMM",
            "COMMENT",
            "COMMIT",
            "COMMITTED",
            "COMPACT",
            "COMPARE",
            "COMPARISONS",
            "COMPRESS",
            "COMPRESSION",
            "CONCAT",
            "CONDITION",
            "CONN",
            "CONNECT",
            "CONNECTIONS",
            "CONNECTOPT",
            "CONNHEADER",
            "CONNMEMUSE",
            "CONSERVATIVE",
            "CONSTRAINT",
            "CONSTRAINTS",
            "CONSTRUCTOR",
            "CONTAINERS",
            "CONTAINS",
            "CONTENT",
            "CONTINUE",
            "CONTINUOUSLY",
            "CONTROL",
            "COPY",
            "COUNT",
            "COUNT_BIG",
            "CPU",
            "CREATE",
            "CREATE_EXTERNAL_ROUTINE",
            "CREATEIN",
            "CREATE_NOT_FENCED",
            "CREATE_NOT_FENCED_ROUTINE",
            "CREATETAB",
            "CS",
            "CUBE",
            "CURRENT",
            "CURRENT_DATE",
            "CURRENT_DEFAULT_TRANSFORM_GROU" +
            "P",
            "CURRENT_PATH",
            "CURRENT_ROLE",
            "CURRENT_TIME",
            "CURRENT_TIMESTAMP",
            "CURRENT_TRANSFORM_GROUP_FOR_TY" +
            "PE",
            "CURRENT_USER",
            "CURRVAL",
            "CURSOR",
            "CURSORS",
            "CYCLE",
            "DATA",
            "DATABASE",
            "DATALINK",
            "DATE",
            "DAY",
            "DAYS",
            "DB",
            "DBADM",
            "DBCLOB",
            "DBINFO",
            "DBMEMUSE",
            "DBPARTITIONNUM",
            "DBPARTITIONNUMS",
            "DB2DARI",
            "DB2GENRL",
            "DB2GENERAL",
            "DB2OPTIONS",
            "DB2SPL",
            "DB2SQL",
            "DB2_RETURN_STATUS",
            "DB2_TOKEN_STRING",
            "DEACTIVATE",
            "DEADLOCK",
            "DEADLOCKS",
            "DEC",
            "DECIMAL",
            "DECLARE",
            "DEFAULT",
            "DEFAULTS",
            "DEFINE",
            "DEFINITION",
            "DEGREE",
            "DEFER",
            "DEFERRED",
            "DELETE",
            "DESC",
            "DESCRIPTOR",
            "DETAILED",
            "DETAILS",
            "DETERMINED",
            "DETERMINISTIC",
            "DEVICE",
            "DIAGNOSTICS",
            "DIMENSIONS",
            "DIRTY",
            "DISABLE",
            "DISALLOW",
            "DISPATCH",
            "DISTINCT",
            "DISTRIBUTION",
            "DLCONN",
            "DLLOCK",
            "DO",
            "DOUBLE",
            "DROP",
            "DROPIN",
            "DROPPED",
            "DYNAMIC",
            "EACH",
            "ELEMENT",
            "ELSE",
            "ELSEIF",
            "EMPTY",
            "ENABLE",
            "ENCRYPTION",
            "END",
            "ENDING",
            "ENFORCED",
            "ERASE",
            "ESCAPE",
            "ESTIMATE",
            "EUR",
            "EVALUATE",
            "EVENT",
            "EXACT",
            "EXCEPT",
            "EXCEPTION",
            "EXCLUDE",
            "EXCLUDES",
            "EXCLUDING",
            "EXCLUSIVE",
            "EXECNODE",
            "EXECUTE",
            "EXISTS",
            "EXIT",
            "EXPAND",
            "EXPLAIN",
            "EXPRESSION",
            "EXTEND",
            "EXTENDED",
            "EXTENSION",
            "EXTENTSIZE",
            "EXTERNAL",
            "FALSE",
            "FEDERATED",
            "FEDERATED_TOOL",
            "FENCED",
            "FETCH",
            "FILE",
            "FILTER",
            "FINAL",
            "FIRST",
            "FLOAT",
            "FLUSH",
            "FOLLOWING",
            "FOR",
            "FORCE",
            "FOREIGN",
            "_FOREIGNKEY",
            "FOUND",
            "FREE",
            "FREEPAGE",
            "FROM",
            "FS",
            "FULL",
            "FUNCTION",
            "G",
            "GBPCACHE",
            "GENERAL",
            "GENERATE",
            "GENERATED",
            "GET",
            "GLOBAL",
            "GOTO",
            "GRANT",
            "GRAPHIC",
            "GROUP",
            "GROUPING",
            "HANDLER",
            "HASHING",
            "HAVING",
            "HIDDEN",
            "HIERARCHY",
            "HIGH",
            "HOLD",
            "HOUR",
            "HOURS",
            "HPJ",
            "ID",
            "IDENTITY",
            "IF",
            "IGNORE",
            "IMMEDIATE",
            "IMPLICIT_SCHEMA",
            "IN",
            "INCLUDE",
            "INCLUDES",
            "INCLUDING",
            "INCREMENT",
            "INCREMENTAL",
            "INDEX",
            "INDEXES",
            "INDICATOR",
            "INFIX",
            "INFO",
            "INHERIT",
            "INITIALLY",
            "INITIAL_INSTS",
            "INITIAL_IOS",
            "INLINE",
            "INNER",
            "INOUT",
            "INPUT",
            "INSENSITIVE",
            "INSERT",
            "INSTANTIABLE",
            "INSTEAD",
            "INSTS_PER_ARGBYTE",
            "INSTS_PER_INVOC",
            "INT",
            "INTEGER",
            "INTEGRITY",
            "INTERSECT",
            "INTO",
            "IO",
            "IOS_PER_ARGBYTE",
            "IOS_PER_INVOC",
            "IS",
            "ISO",
            "ITERATE",
            "ISOLATION",
            "JAVA",
            "JIS",
            "JOIN",
            "K",
            "KEEP",
            "KEY",
            "KEYS",
            "L",
            "LANGUAGE",
            "LARGE",
            "LAST",
            "LATERAL",
            "LC_CTYPE",
            "LEADING",
            "LEAVE",
            "LEFT",
            "LENGTH",
            "LEVEL",
            "LEVEL2",
            "LIBRARY",
            "LIBRARYADM",
            "LIKE",
            "LIMIT",
            "LINK",
            "LINKTYPE",
            "LOAD",
            "LOCAL",
            "LOCALE",
            "LOCALTIME",
            "LOCALTIMESTAMP",
            "LOCATOR",
            "LOCATORS",
            "LOCK",
            "LOCKS",
            "LOCKSIZE",
            "LOG",
            "LOGGED",
            "LONG",
            "LONGVAR",
            "LOOP",
            "LOW",
            "M",
            "MAIN_PROG",
            "MANAGED",
            "MANUALSTART",
            "MAPPING",
            "MATCHED",
            "MATERIALIZED",
            "MAXFILES",
            "MAXFILESIZE",
            "MAXVALUE",
            "MDC",
            "MERGE",
            "MESSAGE_TEXT",
            "METHOD",
            "METHODS",
            "MICROSECOND",
            "MICROSECONDS",
            "MINPCTUSED",
            "MINUTE",
            "MINUTES",
            "MINVALUE",
            "MIXED",
            "MODE",
            "MODIFIES",
            "MONITOR",
            "MONTH",
            "MONTHS",
            "MOVEMENT",
            "MULTISET",
            "N",
            "NAME",
            "NEW",
            "NEW_TABLE",
            "NEXT",
            "NEXTVAL",
            "NICKNAME",
            "NO",
            "NOCACHE",
            "NOCYCLE",
            "NODE",
            "NODES",
            "NODEGROUP",
            "NOMAXVALUE",
            "NOMINVALUE",
            "NONBLOCKED",
            "NONE",
            "NOORDER",
            "NOT",
            "NULL",
            "NULLS",
            "NUM",
            "NUMBLOCKPAGES",
            "NUMERIC",
            "NUM_FREQVALUES",
            "NUM_QUANTILES",
            "OBJECT",
            "OF",
            "OFF",
            "OLD",
            "OLD_TABLE",
            "OLE",
            "OLEDB",
            "ON",
            "ONCE",
            "ONLINE",
            "ONLY",
            "OPEN",
            "OPTIMIZATION",
            "OPTIMIZE",
            "OPTION",
            "OPTIONS",
            "OR",
            "ORDER",
            "ORGANIZE",
            "OUT",
            "OUTER",
            "OVER",
            "OVERFLOW",
            "OVERHEAD",
            "OVERRIDING",
            "P",
            "PACKAGE",
            "PAGE",
            "PAGESIZE",
            "PARALLEL",
            "PARAMETER",
            "PASSTHRU",
            "PASSWORD",
            "PATH",
            "PARTITION",
            "PARTITIONING",
            "PARTITIONINGS",
            "PATROLLER",
            "PCTDEACTIVATE",
            "PCTFREE",
            "PENDING",
            "PERCENT_ARGBYTES",
            "PERMISSION",
            "PIECESIZE",
            "PIPE",
            "PLAN",
            "PRECEDING",
            "PRECISION",
            "PREDICATES",
            "PREFETCHSIZE",
            "PREPARE",
            "PRESERVE",
            "PREVIOUS",
            "PREVVAL",
            "PRIMARY",
            "_PRIMARYKEY",
            "PRIQTY",
            "PRIVILEGES",
            "PROCEDURE",
            "PROFILE",
            "PROGRAM",
            "PROPAGATE",
            "PROTOCOL",
            "PRUNE",
            "PUBLIC",
            "QUERY",
            "QUERYNO",
            "QUERYTAG",
            "QUIESCE_CONNECT",
            "RANGE",
            "RATE",
            "RATIO",
            "READ",
            "READS",
            "REAL",
            "RECOMMEND",
            "RECONCILE",
            "RECOVERY",
            "RECREATE",
            "REDUCE",
            "REF",
            "REFERENCE",
            "REFERENCES",
            "REFERENCING",
            "REFRESH",
            "REGISTERS",
            "REGULAR",
            "RELEASE",
            "REMAIN",
            "REMOTE",
            "RENAME",
            "REOPT",
            "REPEATABLE",
            "REPEAT",
            "REPLACE",
            "REPLICATED",
            "REQUIRING",
            "RESET",
            "RESIDENT",
            "RESIGNAL",
            "RESIZE",
            "RESOLVE",
            "RESTART",
            "RESTORE",
            "RESTRICT",
            "RESULT",
            "RESULT_SET_LOCATOR",
            "RETAIN",
            "RETURN",
            "RETURNS",
            "RETURN_STATUS",
            "REVERSE",
            "REVOKE",
            "RIGHT",
            "ROLLBACK",
            "ROLLUP",
            "ROUTINE",
            "ROW",
            "ROW_COUNT",
            "ROWS",
            "RR",
            "RS",
            "RUN",
            "S",
            "SAMPLED",
            "SAVEPOINT",
            "SBCS",
            "SCANS",
            "SCHEMA",
            "SCOPE",
            "SCRATCHPAD",
            "SCROLL",
            "SEARCH",
            "SECOND",
            "SECONDS",
            "SECQTY",
            "SECURITYADM",
            "SELECT",
            "SELECTION",
            "SELECTIVE",
            "SELECTIVITY",
            "SELF",
            "SENSITIVE",
            "SEQUENCE",
            "SERIALIZABLE",
            "SERVER",
            "SESSION",
            "SESSION_USER",
            "SET",
            "SETS",
            "SETTING",
            "SHARE",
            "SHRLEVEL",
            "SIGNAL",
            "SIMPLE",
            "SIZE",
            "SMALLINT",
            "SNAPSHOT",
            "SOME",
            "SOURCE",
            "SPECIAL",
            "SPECIFIC",
            "SPECIFICATION",
            "SPLIT",
            "SQL",
            "SQLDATA",
            "SQLERROR",
            "SQLEXCEPTION",
            "SQLWARNING",
            "SQLID",
            "SQLMACRO",
            "SQLSTATE",
            "SSA",
            "STABILITY",
            "STAGING",
            "START",
            "STATE",
            "STATEMENT",
            "STATEMENTS",
            "STATIC",
            "STATISTICS",
            "STARTING",
            "STAY",
            "STMT",
            "STOGROUP",
            "STORAGE",
            "STORED",
            "STRIP",
            "STRIPE",
            "STYLE",
            "SUB",
            "SUBSECTION",
            "SUMMARY",
            "SWITCH",
            "SYMMETRIC",
            "SYNONYM",
            "SYSTEM",
            "SYSTEM_USER",
            "T",
            "TABLE",
            "TABLES",
            "TABLESAMPLE",
            "TABLESPACE",
            "TABLESPACES",
            "TARGET",
            "TEMPLATE",
            "TEMPORARY",
            "THEN",
            "THREADSAFE",
            "THROUGH",
            "TIME",
            "TIMEOUT",
            "TIMESTAMP",
            "TIMEZONE",
            "TO",
            "TOKEN",
            "TRAILING",
            "TRANSACTIONS",
            "TRANSFERRATE",
            "TRANSFORM",
            "TRANSFORMS",
            "TRANSLATE",
            "TREAT",
            "TRIGGER",
            "TRUE",
            "TRUNC",
            "TWOLEVEL",
            "TYPE",
            "TYPES",
            "UNBOUNDED",
            "UNCHECKED",
            "UNCOMMITTED",
            "UNDER",
            "UNDO",
            "UNICODE",
            "UNION",
            "UNIQUE",
            "UNLINK",
            "UNTIL",
            "UPDATE",
            "UR",
            "URL",
            "USA",
            "USE",
            "USAGE",
            "USER",
            "USERID",
            "USING",
            "VALUE",
            "VALUES",
            "VARCHAR",
            "VARGRAPHIC",
            "VARIANT",
            "VARYING",
            "VCAT",
            "VERSION",
            "VIEW",
            "VOLATILE",
            "WAIT",
            "WHEN",
            "WHERE",
            "WHILE",
            "WITH",
            "WITHOUT",
            "WORK",
            "WRAPPER",
            "WRITE",
            "WRKSTNNAME",
            "X",
            "XACT",
            "YEAR",
            "YEARS",
            "YES",
            "ABSENT",
            "ACCORDING",
            "BASE64",
            "DOCUMENT",
            "ENCODING",
            "HEX",
            "LOCATION",
            "NAMESPACE",
            "NIL",
            "ORDINALITY",
            "PASSING",
            "PI",
            "RETURNING",
            "URI",
            "WHITESPACE",
            "XML",
            "XMLAGG",
            "XMLATTRIBUTES",
            "XMLBINARY",
            "XMLCAST",
            "XMLCOMMENT",
            "XMLCONCAT",
            "XMLDECLARATION",
            "XMLDOCUMENT",
            "XMLELEMENT",
            "XMLEXISTS",
            "XMLFOREST",
            "XMLNAMESPACES",
            "XMLPARSE",
            "XMLPI",
            "XMLQUERY",
            "XMLSCHEMA",
            "XMLSERIALIZE",
            "XMLTABLE",
            "XMLTEXT",
            "XMLVALIDATE",
            "VERTICAL_BAR",
            "REGULAR_IDENTIFIER",
            "DELIMITED_IDENTIFIER",
            "EMBEDDED_VARIABLE_NAME",
            "UNSIGNED_INTEGER",
            "SUFFIXED_UNSIGNED_INTEGER",
            "EXACT_NUMERIC_LITERAL",
            "APPROXIMATE_NUMERIC_LITERAL",
            "NATIONAL_CHAR_STRING_LITERAL",
            "NATIONAL_HEX_STRING_LITERAL",
            "BIT_STRING_LITERAL",
            "HEX_STRING_LITERAL",
            "CHAR_STRING_LITERAL",
            "COMMENT_STRING",
            "DELIMITED_TYPE_IDENTIFIER",
            "VERSION_IDENTIFIER",
            "STATEMENT_TERMINATOR",
            "HOSTVARIABLE",
            "PARAMETER_MARKER",
            "LEFT_BRACKET_TRIGRAPH",
            "RIGHT_BRACKET_TRIGRAPH",
            "EOLN",
            "<merge_on_condition>",
            "<merge_source_table>",
            "<merge_target_table>",
            "<target_table>",
            "<expression>",
            "<sql_dml_stmt_list>",
            "<sql_dml_stmt_xspan>",
            "<alias_name>",
            "<identifier>",
            "<relop>",
            "<subquery>",
            "<argument>",
            "<argument_list_body>",
            "<as_alias>",
            "<boolean_expression>",
            "<boolean_term>",
            "<boolean_factor>",
            "<boolean_primary>",
            "<boolean_values>",
            "<simplecomp>",
            "<procedure_object>",
            "<case_search_when_list>",
            "<case_simple_when_list>",
            "<case_search_when>",
            "<condition>",
            "<case_simple_when>",
            "<cast_operand>",
            "<cast_target>",
            "<datatype>",
            "<column>",
            "<column_name>",
            "<column_name_list>",
            "<column_ref>",
            "<table>",
            "<datatype_path-resolved_user-d" +
            "efined_type_name>",
            "<left_bracket_or_trigraph>",
            "<right_bracket_or_trigraph>",
            "<target_column_list>",
            "<duration>",
            "<query_exp>",
            "<expression_term>",
            "<expression_commalist>",
            "<expression_factor>",
            "<row_or_rows>",
            "<grouping_exp>",
            "<grouping_sets_element_list>",
            "<grouping_sets_element>",
            "<grouping_sets_element_exp_lis" +
            "t>",
            "<grouping_sets_element_exp>",
            "<grouping_spec>",
            "<grouping_spec_list>",
            "<insert_row>",
            "<insert_row_commalist>",
            "<query_exp_root>",
            "<merge operation specification" +
            " list>",
            "<table_ref>",
            "<merge when clause>",
            "<merge update specification>",
            "<merge insert specification>",
            "<update_assignment_clause>",
            "<super_groups_element_list>",
            "<ordering_spec_commalist>",
            "<schema>",
            "<table_correlation>",
            "<ordering_spec>",
            "<project>",
            "<query_combined_operator>",
            "<query_term>",
            "<selection>",
            "<values_row_commalist>",
            "<value_expr_row>",
            "<timestamp precision>",
            "<time precision>",
            "<super_groups_element_exp>",
            "<super_groups_element_exp_list" +
            ">",
            "<super_groups_element>",
            "<update_assignment_expression_" +
            "commalist>",
            "<update_assignment_expression>",
            "<values_row>",
            "<with_table_spec_list>",
            "<with_table_spec>"
        };
    };
    public final static String name[] = Name.name;
    public final String name(int index) { return name[index]; }

    public final static int
           ERROR_SYMBOL      = 779,
           SCOPE_UBOUND      = 55,
           SCOPE_SIZE        = 56,
           MAX_NAME_LENGTH   = 47;

    public final int getErrorSymbol() { return ERROR_SYMBOL; }
    public final int getScopeUbound() { return SCOPE_UBOUND; }
    public final int getScopeSize() { return SCOPE_SIZE; }
    public final int getMaxNameLength() { return MAX_NAME_LENGTH; }

    public final static int
           NUM_STATES        = 406,
           NT_OFFSET         = 779,
           LA_STATE_OFFSET   = 3421,
           MAX_LA            = 1,
           NUM_RULES         = 413,
           NUM_NONTERMINALS  = 172,
           NUM_SYMBOLS       = 951,
           SEGMENT_SIZE      = 8192,
           START_STATE       = 588,
           IDENTIFIER_SYMBOL = 104,
           EOFT_SYMBOL       = 761,
           EOLT_SYMBOL       = 778,
           ACCEPT_ACTION     = 2522,
           ERROR_ACTION      = 3008;

    public final static boolean BACKTRACK = true;

    public final int getNumStates() { return NUM_STATES; }
    public final int getNtOffset() { return NT_OFFSET; }
    public final int getLaStateOffset() { return LA_STATE_OFFSET; }
    public final int getMaxLa() { return MAX_LA; }
    public final int getNumRules() { return NUM_RULES; }
    public final int getNumNonterminals() { return NUM_NONTERMINALS; }
    public final int getNumSymbols() { return NUM_SYMBOLS; }
    public final int getSegmentSize() { return SEGMENT_SIZE; }
    public final int getStartState() { return START_STATE; }
    public final int getStartSymbol() { return lhs[0]; }
    public final int getIdentifierSymbol() { return IDENTIFIER_SYMBOL; }
    public final int getEoftSymbol() { return EOFT_SYMBOL; }
    public final int getEoltSymbol() { return EOLT_SYMBOL; }
    public final int getAcceptAction() { return ACCEPT_ACTION; }
    public final int getErrorAction() { return ERROR_ACTION; }
    public final boolean isValidForParser() { return isValidForParser; }
    public final boolean getBacktrack() { return BACKTRACK; }

    public final int originalState(int state) {
        return -baseCheck[state];
    }
    public final int asi(int state) {
        return asb[originalState(state)];
    }
    public final int nasi(int state) {
        return nasb[originalState(state)];
    }
    public final int inSymbol(int state) {
        return inSymb[originalState(state)];
    }

    public final int ntAction(int state, int sym) {
        return baseAction[state + sym];
    }

    public final int tAction(int state, int sym) {
        if (sym == 0)
            return ERROR_ACTION;
        int i = baseAction[state],
            k = i + sym;
        if (termCheck[k] == sym)
            return termAction[k];
        i = termAction[i];
        return (shiftCheck[shiftState[i] + sym] == sym
                                ? defaultShift[sym]
                                : defaultReduce[i]);
    }
    public final int lookAhead(int la_state, int sym) {
        int k = la_state + sym;
        if (termCheck[k] == sym)
            return termAction[k];
        int i = termAction[la_state];
        return (shiftCheck[shiftState[i] + sym] == sym
                                ? defaultShift[sym]
                                : defaultReduce[i]);
    }
}
